/*
 * config for cfgparser
 */

#include "cfg-common.h"

//#ifdef ARC_MPLAYER_CONTROLS
extern  use_arcdemo;
//#endif

// Raymond
extern int get_preview;	
extern int scale_w;
extern int scale_h;

extern int getyuv;

extern int debug_pgu;		// Raymond 2007/03/15

extern int audio_cache;

extern int debug_audio;	// Raymond 2007/03/16

extern int asize_div;		// Raymond 2007/04/10

extern int debug_out_frame_rate;	// Raymond 2007/07/11

extern int nosub;	//Barry 2007-08-20

extern int enable_adv;		// Raymond 2007/11/23

extern int debug_phy;			// Raymond 2007/11/19

extern int hdtv;	//Barry 2007-11-27

// Raymond 2008/02/14
extern int audio_spectrum;
extern int debug_audio_spectrum;

extern int no_set_fr;	// Raymond 2008/03/31

#ifdef BUILD_SK2851		//Barry 2008-05-09
extern int relative;
extern int set_dest, destX, destY;
#endif

//

/*
 * CONF_TYPE_FUNC_FULL :
 * allows own implementations for passing the params
 * 
 * the function receives parameter name and argument (if it does not start with - )
 * useful with a conf.name like 'aa*' to parse several parameters to a function
 * return 0 =ok, but we didn't need the param (could be the filename)
 * return 1 =ok, we accepted the param
 * negative values: see cfgparser.h, ERR_XXX
 *
 * by Folke
 */

m_option_t mplayer_opts[]={
	/* name, pointer, type, flags, min, max */

//---------------------- libao/libvo options ------------------------
	
	{"vo", &video_driver_list, CONF_TYPE_STRING_LIST, 0, 0, 0, NULL},
	{"ao", &audio_driver_list, CONF_TYPE_STRING_LIST, 0, 0, 0, NULL},

	// direct rendering (decoding to video out buffer)
	{"dr", &vo_directrendering, CONF_TYPE_FLAG, 0, 0, 1, NULL},

	// Raymond
	{"preview", &get_preview, CONF_TYPE_FLAG, 0, 0, 1, NULL},	
	{"sx", &scale_w, CONF_TYPE_INT, CONF_RANGE, 0, 4096, NULL},
	{"sy", &scale_h, CONF_TYPE_INT, CONF_RANGE, 0, 4096, NULL},

	{"getyuv", &getyuv, CONF_TYPE_FLAG, 0, 0, 1, NULL},	

	{"acache", &audio_cache, CONF_TYPE_FLAG, 0, 0, 1, NULL},	// Raymond 2007/03/12

	{"adebug", &debug_audio, CONF_TYPE_FLAG, 0, 0, 1, NULL},	// Raymond 2007/03/16

	{"debugpgu", &debug_pgu, CONF_TYPE_FLAG, 0, 0, 1, NULL},	// Raymond 2007/03/15

	{"noscale", &HW_Scalar, CONF_TYPE_FLAG, 0, 1, 0, NULL},	// Raymond 2006/12/20

	{"asizediv", &asize_div, CONF_TYPE_INT, CONF_RANGE, 1, 8, NULL},	// Raymond 2007/04/10

	{"dfr", &debug_out_frame_rate, CONF_TYPE_FLAG, 0, 0, 1, NULL},	// Raymond 2007/03/15

	{"nosub", &nosub, CONF_TYPE_FLAG, 0, 0, 1, NULL},		//Barry 2007-08-20

	{"adv", &enable_adv, CONF_TYPE_FLAG, 0, 0, 1, NULL},	// Raymond 2007/11/23

	{"dphy", &debug_phy, CONF_TYPE_FLAG, 0, 0, 1, NULL},	// Raymond 2007/11/19

	{"hdtv", &hdtv, CONF_TYPE_FLAG, 0, 0, 1, NULL},		//Barry 2007-11-27

	// Raymond 2008/02/14
	{"aspec", &audio_spectrum, CONF_TYPE_FLAG, 0, 0, 1, NULL},	
	{"daspec", &debug_audio_spectrum, CONF_TYPE_FLAG, 0, 0, 1, NULL},	

	{"nosetfr", &no_set_fr, CONF_TYPE_FLAG, 0, 0, 1, NULL},	// Raymond 2008/03/31

#ifdef BUILD_SK2851		//Barry 2008-05-09
	{"relative", &relative, CONF_TYPE_FLAG, 0, 0, 1, NULL},

	{"setdest", &set_dest, CONF_TYPE_FLAG, 0, 0, 1, NULL},	
	{"dx", &destX, CONF_TYPE_INT, CONF_RANGE, 0, 4096, NULL},
	{"dy", &destY, CONF_TYPE_INT, CONF_RANGE, 0, 4096, NULL},
#endif
	
//---------------------- mplayer-only options ------------------------

	{"sstep", &step_sec, CONF_TYPE_INT, CONF_MIN, 0, 0, NULL},

	{"framedrop", &frame_dropping, CONF_TYPE_FLAG, 0, 0, 1, NULL},
	{"hardframedrop", &frame_dropping, CONF_TYPE_FLAG, 0, 0, 2, NULL},
	{"noframedrop", &frame_dropping, CONF_TYPE_FLAG, 0, 1, 0, NULL},

	{"benchmark", &benchmark, CONF_TYPE_FLAG, 0, 0, 1, NULL},

	// dump some stream out instead of playing the file
	// this really should be in MEncoder instead of MPlayer... -> TODO
	{"dumpfile", &stream_dump_name, CONF_TYPE_STRING, 0, 0, 0, NULL},
	{"dumpaudio", &stream_dump_type, CONF_TYPE_FLAG, 0, 0, 1, NULL},
	{"dumpvideo", &stream_dump_type, CONF_TYPE_FLAG, 0, 0, 2, NULL},

	{"noloop", &loop_times, CONF_TYPE_FLAG, 0, 0, -1, NULL},
	{"loop", &loop_times, CONF_TYPE_INT, CONF_RANGE, -1, 10000, NULL},
	{"playlist", NULL, CONF_TYPE_STRING, 0, 0, 0, NULL},

#define MAIN_CONF
#include "cfg-common.h"
#undef MAIN_CONF
        
	{"identify", &identify, CONF_TYPE_FLAG, CONF_GLOBAL, 0, 1, NULL},
	{"really-quiet", &verbose, CONF_TYPE_FLAG, CONF_GLOBAL, 0, -10, NULL},
	{"-help", help_text, CONF_TYPE_PRINT, CONF_NOCFG|CONF_GLOBAL, 0, 0, NULL},
	{"help", help_text, CONF_TYPE_PRINT, CONF_NOCFG|CONF_GLOBAL, 0, 0, NULL},
	{"h", help_text, CONF_TYPE_PRINT, CONF_NOCFG|CONF_GLOBAL, 0, 0, NULL},

//#ifdef ARC_MPLAYER_CONTROLS
	{"arcdemo", &use_arcdemo, CONF_TYPE_FLAG, CONF_GLOBAL, 0, 1, NULL},
//#endif
	{NULL, NULL, 0, 0, 0, 0, NULL}
};
