//**************************************************************************//
//             .SUB 
//**************************************************************************//

#include "config.h"

int check_ascii = 0;	// Raymond 2008/08/18

#ifdef USE_OSD

#include <stdio.h>

#include "libvo/video_out.h"
#include "libvo/sub.h"
#include "subreader.h"

#include "mp_msg.h"
#include "help_mp.h"

static int current_sub=0;

//static subtitle* subtitles=NULL;
static int nosub_range_start=-1;
static int nosub_range_end=-1;

extern float sub_delay;
extern float  sub_fps;

#if 0	//Barry 2007-08-22
//Barry 2007-04-18
#include "caption.c"
#include "libarcavcodec/pgu_lib.h"
#else
//#include "libarcavcodec/pgu_lib.h"	//Barry 2008-05-12
#include "libmpcodecs/pgu_lib.h"		//Barry 2008-07-30
//Barry 2008-05-29
//#include "FontDB.h"
#include "textutil.h"

//Barry 2008-06-20
//extern struct yuv_info mp_yuv;		//Barry 2008-07-30
extern int audio_osd;
#include "string.h"		//Barry 2008-07-11
#endif

#if 1	//Barry 2007-08-22
//#define WHITE ENCODE_RGBA5551(255,255,255,1)	//Barry 2008-06-18
#define DT_LEFT             0x00000000
#define DT_CENTER           0x00000001
#define DT_RIGHT            0x00000002
//#define USE_FONTAA
//extern FONT_DB *g_pFontDB_Default;		//Barry 2008-05-29
#endif

//unsigned short *framebuf;		//Barry 2008-06-18
int sub_enable = 0, play_sub_index = -1;

#ifdef BUILD_SK2851		//Barry 2008-05-09
int start_x = 0, start_y = 0, line_index = 0;
//Barry 2008-06-18
#define WHITE	ENCODE_SK2851_OSD_DATA(1, 3, 7, 3)
unsigned char *framebuf;

//Barry 2008-08-18
#define time_on		28+26+7
#define time_off		50+7
#include "skysyscalls.h"

#else
int start_x = 0, start_y = 0, line_index = 0, sub_len = 0;
//Barry 2008-06-18
#define WHITE	ENCODE_RGBA5551(255,255,255,1)
unsigned short *framebuf;

//Barry 2008-07-11
#define time_off_s		32		// H < 450
#define time_off_l		32+22	// H >= 450
#endif
char *sub_info;

#ifdef BUILD_SK2851		//Barry 2008-05-09
int show_first = 0;
#else
//Barry 2007-08-20
char space[1]=" ";
int disp, show_first = 0;		//Barry 2007-12-12
#endif

extern int speed_mult;	//Barry 2007-11-07
int fontsize = 0;			//Barry 2007-12-12
int video_time = 0;		//Barry 2008-01-07

void step_sub(sub_data *subd, float pts, int movement) {
    subtitle *subs; 
    int key;

    if (subd == NULL) return;
    subs = subd->subtitles;
    key = (pts+sub_delay) * (subd->sub_uses_time ? 100 : sub_fps);

    /* Tell the OSD subsystem that the OSD contents will change soon */
    vo_osd_changed(OSDTYPE_SUBTITLE);

    /* If we are moving forward, don't count the next (current) subtitle
     * if we haven't displayed it yet. Same when moving other direction.
     */
    if (movement > 0 && key < subs[current_sub].start)
    	movement--;
    if (movement < 0 && key >= subs[current_sub].end)
    	movement++;

    /* Never move beyond first or last subtitle. */
    if (current_sub+movement < 0)
    	movement = 0-current_sub;
    if (current_sub+movement >= subd->sub_num)
    	movement = subd->sub_num - current_sub - 1;

    current_sub += movement;
    sub_delay = subs[current_sub].start / (subd->sub_uses_time ? 100 : sub_fps) - pts;
}


#if 1	//Barry 2007-08-22
//------------------------------------------------------------------------------------------------
#ifndef BUILD_SK2851		//Barry 2008-05-09
void CenterAlignment(char *src){
	int add_space=0, j;
	char align_sub[64];
	memset(align_sub, '\0', sizeof(align_sub));

	if (strlen(src) > 29)
		strncat(align_sub, src, 29);
	else{
		add_space = (29-strlen(src)+1)/2;
		for (j=0;j<add_space;j++)
			strncat(align_sub, &space[0], 1);
		strncat(align_sub, src, strlen(src));
	}
	strcpy(src, align_sub);
}
#endif
//------------------------------------------------------------------------------------------------
#if 1	//Barry 2008-05-29
Uint16 FontTextOutFormat(FONT_DB *pFontDB, Uint16 *RGBFrame, int x, int y, BYTE *str, Uint16 color, Uint32 nFormat)
{
	Uint16 StrWidth, StrWidth_2;
	Uint16 MaxWidth = 0;		//w]e
	
	if (nFormat & DT_CENTER)
	{
		StrWidth = GetFontStringWidth(pFontDB, str);
		StrWidth_2 = StrWidth / 2;
		if (x < StrWidth_2)
			x = 0;
		else
			x -= StrWidth_2;
		MaxWidth = 0;
	}
	else if (nFormat & DT_RIGHT)
	{
		MaxWidth = x;
		StrWidth = GetFontStringWidth(pFontDB, str);
		if (x < StrWidth)
			x = 0;
		else
			x -= StrWidth;
		MaxWidth = MaxWidth - x + 1;
	}

#ifdef BUILD_SK2851		//Barry 2008-06-18
	return FontTextOutAlign(pFontDB, RGBFrame, DispX_def, x, y, MaxWidth, str, color);
#else
	//Barry 2008-06-20
//	if (audio_osd)		//Barry 2008-07-30
		return FontTextOutAlign(pFontDB, RGBFrame, mp_yuv.y_stride, x, y, MaxWidth, str, color);
#if 0	//Barry 2008-07-30
	else
		return FontTextOutAlign(pFontDB, RGBFrame, yuv.y_stride, x, y, MaxWidth, str, color);
#endif
#endif
}
#endif
//------------------------------------------------------------------------------------------------
#endif

#ifdef BUILD_SK2851		//Barry 2008-05-09


void find_sub(sub_data* subd,int key){
    subtitle *subs;
    int i,j;
//    char *sub_info;


    //Barry 2007-11-07
    if (speed_mult != 0){
		//if (!show_first)
		if (!show_first || !sub_enable)	//Barry 2007-11-21
			return;
		else{
			if (video_time)	//Barry 2008-01-07
				memset(&framebuf[DispX_def*(DispY - (subd->subtitles[current_sub].lines*fontsize+time_on))], 0, DispX_def*(subd->subtitles[current_sub].lines*fontsize));	//Barry 2008-05-22
			else
				memset(&framebuf[DispX_def*(DispY - (subd->subtitles[current_sub].lines*fontsize+time_off))], 0, DispX_def*(subd->subtitles[current_sub].lines*fontsize));	//Barry 2008-05-22
			sub_enable = 0;
			return;  
		}
    }
    
    if ( !subd || subd->sub_num == 0) return;
    subs = subd->subtitles;
    
    if(vo_sub){
      if(key>=vo_sub->start && key<=vo_sub->end){ 
      	
	      //Barry 2007-04-18      
	      if ((!sub_enable) || (play_sub_index != current_sub)){
#if 1	//Barry 2008-03-31

			if (!show_first){
				pgu_open_fb();
			#if 1	//Barry 2008-06-18
				framebuf = (unsigned char*)pgu_map_buffer(DispX_def*DispY, 0);
				pgu_set_osd_start_position(SEL_OSD_1, 0, 0);
				pgu_set_osd_end_position(SEL_OSD_1, DispX_def-1, DispY-1);
				pgu_select_osd(SEL_OSD_1, 1);
				pgu_enable_osd(1);
				//video_time = pgu_get_mplayer_time_on_off();		//Barry 2008-01-07
				video_time = syscall_get_video_time_onoff();		//Barry 2008-08-18
			#endif
				show_first++;
			}
			else
			{
				if (current_sub != 0)		//Barry 2008-01-07
				{
					//Barry 2007-11-28
					if (video_time)
						memset(&framebuf[DispX_def*(DispY - (subs[current_sub-1].lines*fontsize+time_on))], 0, DispX_def*(subs[current_sub-1].lines*fontsize));
					else
						memset(&framebuf[DispX_def*(DispY - (subs[current_sub-1].lines*fontsize+time_off))], 0, DispX_def*(subs[current_sub-1].lines*fontsize));
				}
			}

			line_index = 0;
			//Barry 2008-05-29	// for HDTV Barry 2007-08-31
			fontsize = g_pFontDB_Local->FontSize;
			if (g_pFontDB_Local->bScaleDown == 1)
				fontsize = g_pFontDB_Local->FontSize/2;
				
			while(line_index < subs[current_sub].lines){
				sub_info = subs[current_sub].text[line_index];
				start_x = DispX_def>>1;	//Barry 2008-06-18
				if (!line_index)
				{
					//Barry 2007-11-28
					if (video_time)	//Barry 2008-01-07
						start_y = DispY - (fontsize*subs[current_sub].lines+time_on);
					else
						start_y = DispY - (fontsize*subs[current_sub].lines+time_off);
				}
				else
				{
					//Barry 2007-11-28
					start_y += fontsize;
				}
				FontTextOutFormat(g_pFontDB_Local, (Uint16 *)framebuf, start_x, start_y, subs[current_sub].text[line_index], WHITE, DT_CENTER);		//Barry 2008-05-29
				line_index++;
			}
			sub_enable = 1;
			play_sub_index = current_sub;
#endif		  
		}
		  
	      return; // OK!
      }
    } else {
      if(key>nosub_range_start && key<nosub_range_end){
	  	
	      if (sub_enable){
#if 1	//Barry 2008-03-31
			//Barry 2007-11-28
			if (video_time)	//Barry 2008-01-07
				memset(&framebuf[DispX_def*(DispY - (subs[current_sub].lines*fontsize+time_on))], 0, DispX_def*(subs[current_sub].lines*fontsize));
			else
				memset(&framebuf[DispX_def*(DispY - (subs[current_sub].lines*fontsize+time_off))], 0, DispX_def*(subs[current_sub].lines*fontsize));
			if (current_sub == subd->sub_num-1)
				pgu_close_fb();
		      sub_enable = 0;
#else
		      pgu_enable_overlay(0);
		      pgu_close_fb();
		      sub_enable = 0;
#endif
	      }
	      //printf("No Sub-title \n\n\n");
	      return;
      } // OK!
    }
    // sub changed!

    /* Tell the OSD subsystem that the OSD contents will change soon */
    vo_osd_changed(OSDTYPE_SUBTITLE);

    if(key<=0){
      vo_sub=NULL; // no sub here
      return;
    }
    
//    printf("\r---- sub changed ----\n");
    
    // check next sub.
    if(current_sub>=0 && current_sub+1 < subd->sub_num){
      if(key>subs[current_sub].end && key<subs[current_sub+1].start){
          // no sub
          nosub_range_start=subs[current_sub].end;
          nosub_range_end=subs[current_sub+1].start;
          vo_sub=NULL;
          return;
      }
      // next sub?
      ++current_sub;
      vo_sub=&subs[current_sub];
      if(key>=vo_sub->start && key<=vo_sub->end) return; // OK!
    }

//    printf("\r---- sub log search... ----\n");
    
    // use logarithmic search:
    i=0; 
    j = subd->sub_num - 1;
//    printf("Searching %d in %d..%d\n",key,subs[i].start,subs[j].end);
    while(j>=i){
        current_sub=(i+j+1)/2;
        vo_sub=&subs[current_sub];
        if(key<vo_sub->start) j=current_sub-1;
        else if(key>vo_sub->end) i=current_sub+1;
        else return; // found!
    }
//    if(key>=vo_sub->start && key<=vo_sub->end) return; // OK!
    
    // check where are we...
    if(key<vo_sub->start){
      if(current_sub<=0){
          // before the first sub
          nosub_range_start=key-1; // tricky
          nosub_range_end=vo_sub->start;
//          printf("FIRST...  key=%d  end=%d  \n",key,vo_sub->start);
          vo_sub=NULL;
          return;
      }
      --current_sub;
      if(key>subs[current_sub].end && key<subs[current_sub+1].start){
          // no sub
          nosub_range_start=subs[current_sub].end;
          nosub_range_end=subs[current_sub+1].start;
//          printf("No sub... 1 \n");
          vo_sub=NULL;
          return;
      }
      printf("HEH????  ");
    } else {
      if(key<=vo_sub->end) printf("JAJJ!  "); else
      if(current_sub+1 >= subd->sub_num){
          // at the end?
          nosub_range_start=vo_sub->end;
          nosub_range_end=0x7FFFFFFF; // MAXINT
//          printf("END!?\n");
          vo_sub=NULL;
          return;
      } else
      if(key>subs[current_sub].end && key<subs[current_sub+1].start){
          // no sub
          nosub_range_start=subs[current_sub].end;
          nosub_range_end=subs[current_sub+1].start;
//          printf("No sub... 2 \n");
          vo_sub=NULL;
          return;
      }
    }
    
    mp_msg(MSGT_FIXME,MSGL_FIXME,"SUB ERROR:  %d  ?  %d --- %d  [%d]  \n",key,(int)vo_sub->start,(int)vo_sub->end,current_sub);

    vo_sub=NULL; // no sub here
}



#else	//SK2850

void find_sub(sub_data* subd,int key){
    subtitle *subs;
    int i,j;
//    char *sub_info;

	//Barry 2007-08-20
	int show_lines=0, sub_count = 0, next_sub_index = 0;//, fontsize = 0;	//Barry 2007-11-21
	char _str[3][31], temp[70], sub_content[90];		//Barry 2007-09-26

    //Barry 2007-11-07
    if (speed_mult != 0){
		//if (!show_first)
		if (!show_first || !sub_enable)	//Barry 2007-11-21
			return;
		else{
			if ((disp == DISP_NTSC)||(disp == DISP_PAL)||(disp == DISP_HDTV))
			{
#if 1	//Barry 2008-07-11
				if (video_time)
				{
					if (mp_yuv.height > 450)
						memset(&framebuf[mp_yuv.y_stride*(mp_yuv.height - (subd->subtitles[current_sub].lines*fontsize+time_off_l+fontsize))], 0, mp_yuv.y_stride*(subd->subtitles[current_sub].lines*fontsize)*2);
					else
						memset(&framebuf[mp_yuv.y_stride*(mp_yuv.height - (subd->subtitles[current_sub].lines*fontsize+time_off_s+fontsize))], 0, mp_yuv.y_stride*(subd->subtitles[current_sub].lines*fontsize)*2);
				}
				else
				{
					if (mp_yuv.height > 450)
						memset(&framebuf[mp_yuv.y_stride*(mp_yuv.height - (subd->subtitles[current_sub].lines*fontsize+time_off_l))], 0, mp_yuv.y_stride*(subd->subtitles[current_sub].lines*fontsize)*2);
					else
						memset(&framebuf[mp_yuv.y_stride*(mp_yuv.height - (subd->subtitles[current_sub].lines*fontsize+time_off_s))], 0, mp_yuv.y_stride*(subd->subtitles[current_sub].lines*fontsize)*2);
				}
#else
				//Barry 2007-11-28
				if (video_time)	//Barry 2008-01-07
					memset(&framebuf[yuv.y_stride*(yuv.height - (subd->subtitles[current_sub].lines*(fontsize+1)+65))], 0, yuv.y_stride*(subd->subtitles[current_sub].lines*(fontsize+1))*2);
				else
					memset(&framebuf[yuv.y_stride*(yuv.height - (subd->subtitles[current_sub].lines*(fontsize+1)+36))], 0, yuv.y_stride*(subd->subtitles[current_sub].lines*(fontsize+1))*2);
#endif
			}
			else
				pgu_clear_mplayer_subtitle();
			sub_enable = 0;
			return;  
		}
    }
    
    if ( !subd || subd->sub_num == 0) return;
    subs = subd->subtitles;
    
    if(vo_sub){
      if(key>=vo_sub->start && key<=vo_sub->end){ 
      	
	      //Barry 2007-04-18      
	      if ((!sub_enable) || (play_sub_index != current_sub)){
#if 0	//Barry 2007-08-20
		      pgu_open_fb();
		      framebuf = (unsigned short*)pgu_map_buffer(RGB_FRAMEBUFF_SIZE, 0);
		      memset(framebuf, 0, RGB_FRAMEBUFF_SIZE);
		      
		      line_index = 0;
		      while(line_index < subs[current_sub].lines){
			      sub_info = subs[current_sub].text[line_index];
			      sub_len = find_sub_len(sub_info);
			      start_x = (yuv.width/2) - (sub_len/2);
			      if (!line_index)
				      start_y = yuv.height - ((CAPTION_FONT_HEIGHT+2)*subs[current_sub].lines+5);
			      else
				      start_y += (CAPTION_FONT_HEIGHT+2);
			      TextOutEnglishCaption((Uint16 *)framebuf, start_x, start_y, subs[current_sub].text[line_index], WHITE);
			      line_index++;
		      }//*/
		      
		      //Barry 2007-04-19
		      pgu_enable_overlay(1);
		      sub_enable = 1;	      
		      play_sub_index = current_sub;
#else
			if (!show_first){
				pgu_open_fb();
				disp = pgu_get_display_index();
			}

			if ((disp == DISP_NTSC)||(disp == DISP_PAL)||(disp == DISP_HDTV)){	//TV mode
			#if 1	//Barry 2007-08-22
				if (!show_first){
					//Barry 2008-07-30
					if (!mp_yuv.y_stride && !mp_yuv.height)
						if (pgu_get_yuv_buffers())
							printf("Find_sub: Can't get YUV info\n");
										
					framebuf = (unsigned short*)pgu_map_buffer(mp_yuv.y_stride*mp_yuv.height*2, 0);	
					pgu_enable_tv_osd(1);
					video_time = pgu_get_mplayer_time_on_off();		//Barry 2008-01-07
					show_first++;
				}
				else
				{
					if (current_sub != 0)		//Barry 2008-01-07
					{
#if 1	//Barry 2008-07-11
						if (video_time)
						{
							if (mp_yuv.height > 450)
								memset(&framebuf[mp_yuv.y_stride*(mp_yuv.height - (subs[current_sub-1].lines*fontsize+time_off_l+fontsize))], 0, mp_yuv.y_stride*(subs[current_sub-1].lines*fontsize)*2);
							else
								memset(&framebuf[mp_yuv.y_stride*(mp_yuv.height - (subs[current_sub-1].lines*fontsize+time_off_s+fontsize))], 0, mp_yuv.y_stride*(subs[current_sub-1].lines*fontsize)*2);
						}
						else
						{
							if (mp_yuv.height > 450)
								memset(&framebuf[mp_yuv.y_stride*(mp_yuv.height - (subs[current_sub-1].lines*fontsize+time_off_l))], 0, mp_yuv.y_stride*(subs[current_sub-1].lines*fontsize)*2);
							else
								memset(&framebuf[mp_yuv.y_stride*(mp_yuv.height - (subs[current_sub-1].lines*fontsize+time_off_s))], 0, mp_yuv.y_stride*(subs[current_sub-1].lines*fontsize)*2);
						}
#else
						//Barry 2007-11-28
						if (video_time)
							memset(&framebuf[yuv.y_stride*(yuv.height - (subs[current_sub-1].lines*(fontsize+1)+65))], 0, yuv.y_stride*(subs[current_sub-1].lines*(fontsize+1))*2);
						else
							memset(&framebuf[yuv.y_stride*(yuv.height - (subs[current_sub-1].lines*(fontsize+1)+36))], 0, yuv.y_stride*(subs[current_sub-1].lines*(fontsize+1))*2);
#endif
					}
				}

				line_index = 0;
				//Barry 2008-05-29	// for HDTV Barry 2007-08-31
				fontsize = g_pFontDB_Local->FontSize;
				if (g_pFontDB_Local->bScaleDown == 1)
					fontsize = g_pFontDB_Local->FontSize/2;
					
				while(line_index < subs[current_sub].lines){
					sub_info = subs[current_sub].text[line_index];
					start_x = mp_yuv.width/2;
					if (!line_index)
					{
#if 1	//Barry 2008-07-11
						if (video_time)
						{
							if (mp_yuv.height > 450)
								start_y = mp_yuv.height - (fontsize*subs[current_sub].lines+time_off_l+fontsize);
							else
								start_y = mp_yuv.height - (fontsize*subs[current_sub].lines+time_off_s+fontsize);
						}
						else
						{
							if (mp_yuv.height > 450)
								start_y = mp_yuv.height - (fontsize*subs[current_sub].lines+time_off_l);
							else
								start_y = mp_yuv.height - (fontsize*subs[current_sub].lines+time_off_s);
						}
#else
						//Barry 2007-11-28
						if (video_time)	//Barry 2008-01-07
							start_y = yuv.height - ((fontsize+1)*subs[current_sub].lines+65);
						else
							start_y = yuv.height - ((fontsize+1)*subs[current_sub].lines+36);
#endif
					}
					else
					{
						//Barry 2007-11-28
						start_y += fontsize;
					}
					FontTextOutFormat(g_pFontDB_Local, (Uint16 *)framebuf, start_x, start_y, subs[current_sub].text[line_index], WHITE, DT_CENTER);		//Barry 2008-05-29
					line_index++;
				}
			#else
				if (!show_first){
					framebuf = (unsigned short*)pgu_map_buffer(yuv.y_stride*yuv.height*2, 0);
					pgu_enable_tv_osd(1);
					show_first++;
				}
				else
					memset(&framebuf[(yuv.y_stride*yuv.height)/2], 0, yuv.y_stride*(yuv.height/2-65)*2);

				line_index = 0;
				while(line_index < subs[current_sub].lines){
					sub_info = subs[current_sub].text[line_index];
					sub_len = find_sub_len(sub_info);
					start_x = (yuv.width/2) - (sub_len/2);
					if (!line_index)
						start_y = yuv.height - ((CAPTION_FONT_HEIGHT+2)*subs[current_sub].lines+65);
					else
						start_y += (CAPTION_FONT_HEIGHT+2);
					TextOutEnglishCaption((Uint16 *)framebuf, start_x, start_y, subs[current_sub].text[line_index], WHITE);
					line_index++;
				}
			#endif
			}
			else{	//LCD mode
				if (!show_first)
					show_first++;
				
				if (check_ascii)
					return;				
				
				show_lines = subs[current_sub].lines;
			#if 1	//Barry 2007-09-26
				memset(_str[0], '\0', sizeof(_str[0]));
				memset(_str[1], '\0', sizeof(_str[1]));
				memset(_str[2], '\0', sizeof(_str[2]));
				memset(sub_content, '\0', sizeof(sub_content));

				line_index = 0; sub_count = 0;
				while (line_index < show_lines){
					sub_count += strlen(subs[current_sub].text[line_index]);

					if (line_index > 0)
						strcat(sub_content, space);
					if (sub_count < (29*3))
						strcat(sub_content, subs[current_sub].text[line_index]);
					else{
						strncat(sub_content, subs[current_sub].text[line_index], 87 - strlen(sub_content));
						sub_count = 87;
						break;
					}
					line_index++;
				}

				line_index = 0;
				while (line_index < 3){
					if (strlen(sub_content) > 29){
						if (line_index < 2){
							next_sub_index = 0;
							if (sub_content[29] == ' '){
								strncpy(_str[line_index], sub_content, 29);
								next_sub_index = 30;
							}
							else{
								for (i=28;i>=0;i--){
									if (sub_content[i] == ' ')
										break;
								}
								strncpy(_str[line_index], sub_content, i);
								next_sub_index = i+1;
							}
							memset(temp, '\0', sizeof(temp));
							for (i = next_sub_index; i < strlen(sub_content);i++)
								temp[i-next_sub_index] = sub_content[i];
							memset(sub_content, '\0', sizeof(sub_content));
							strcpy(sub_content, temp);
						}
						else{
							strncpy(_str[line_index], sub_content, 29);
							line_index++;
							break;
						}						
					}
					else{
						strncpy(_str[line_index], sub_content, strlen(sub_content));
						line_index++;
						break;
					}
					
					line_index++;
				}

				if (line_index == 2){
					strcpy(_str[2], _str[1]);
					memset(_str[1], '\0', sizeof(_str[1]));
					strcpy(_str[1], _str[0]);
					memset(_str[0], '\0', sizeof(_str[0]));
					CenterAlignment(_str[2]);
					CenterAlignment(_str[1]);
				}
				else if (line_index == 1){
					strcpy(_str[2], _str[0]);
					memset(_str[0], '\0', sizeof(_str[0]));
					memset(_str[1], '\0', sizeof(_str[1]));
					CenterAlignment(_str[2]);
				}
				else{
					CenterAlignment(_str[2]);
					CenterAlignment(_str[1]);
					CenterAlignment(_str[0]);
				}
			#endif
				
				pgu_clear_mplayer_subtitle();
				pgu_show_mplayer_subtitle(_str);
			}
		      sub_enable = 1;	      
		      play_sub_index = current_sub;
#endif		  
		}
		  
	      return; // OK!
      }
    } else {
      if(key>nosub_range_start && key<nosub_range_end){
	  	
	      if (sub_enable){
#if 1	//Barry 2007-08-20
			if ((disp == DISP_NTSC)||(disp == DISP_PAL)||(disp == DISP_HDTV))
			{
#if 1	//Barry 2008-07-11
				if (video_time)
				{
					if (mp_yuv.height > 450)
						memset(&framebuf[mp_yuv.y_stride*(mp_yuv.height - (subs[current_sub].lines*fontsize+time_off_l+fontsize))], 0, mp_yuv.y_stride*(subs[current_sub].lines*fontsize)*2);
					else
						memset(&framebuf[mp_yuv.y_stride*(mp_yuv.height - (subs[current_sub].lines*fontsize+time_off_s+fontsize))], 0, mp_yuv.y_stride*(subs[current_sub].lines*fontsize)*2);
				}
				else
				{
					if (mp_yuv.height > 450)
						memset(&framebuf[mp_yuv.y_stride*(mp_yuv.height - (subs[current_sub].lines*fontsize+time_off_l))], 0, mp_yuv.y_stride*(subs[current_sub].lines*fontsize)*2);
					else
						memset(&framebuf[mp_yuv.y_stride*(mp_yuv.height - (subs[current_sub].lines*fontsize+time_off_s))], 0, mp_yuv.y_stride*(subs[current_sub].lines*fontsize)*2);
				}
#else
				//Barry 2007-11-28
				if (video_time)	//Barry 2008-01-07
					memset(&framebuf[yuv.y_stride*(yuv.height - (subs[current_sub].lines*(fontsize+1)+65))], 0, yuv.y_stride*(subs[current_sub].lines*(fontsize+1))*2);
				else
					memset(&framebuf[yuv.y_stride*(yuv.height - (subs[current_sub].lines*(fontsize+1)+36))], 0, yuv.y_stride*(subs[current_sub].lines*(fontsize+1))*2);
#endif
			}
			else{
				if (check_ascii)
					return;
				pgu_clear_mplayer_subtitle();
			}
			if (current_sub == subd->sub_num-1)
				pgu_close_fb();
		      sub_enable = 0;
#else
		      pgu_enable_overlay(0);
		      pgu_close_fb();
		      sub_enable = 0;
#endif
	      }
	      //printf("No Sub-title \n\n\n");
	      return;
      } // OK!
    }
    // sub changed!

    /* Tell the OSD subsystem that the OSD contents will change soon */
    vo_osd_changed(OSDTYPE_SUBTITLE);

    if(key<=0){
      vo_sub=NULL; // no sub here
      return;
    }
    
//    printf("\r---- sub changed ----\n");
    
    // check next sub.
    if(current_sub>=0 && current_sub+1 < subd->sub_num){
      if(key>subs[current_sub].end && key<subs[current_sub+1].start){
          // no sub
          nosub_range_start=subs[current_sub].end;
          nosub_range_end=subs[current_sub+1].start;
          vo_sub=NULL;
          return;
      }
      // next sub?
      ++current_sub;
      vo_sub=&subs[current_sub];
      if(key>=vo_sub->start && key<=vo_sub->end) return; // OK!
    }

//    printf("\r---- sub log search... ----\n");
    
    // use logarithmic search:
    i=0; 
    j = subd->sub_num - 1;
//    printf("Searching %d in %d..%d\n",key,subs[i].start,subs[j].end);
    while(j>=i){
        current_sub=(i+j+1)/2;
        vo_sub=&subs[current_sub];
        if(key<vo_sub->start) j=current_sub-1;
        else if(key>vo_sub->end) i=current_sub+1;
        else return; // found!
    }
//    if(key>=vo_sub->start && key<=vo_sub->end) return; // OK!
    
    // check where are we...
    if(key<vo_sub->start){
      if(current_sub<=0){
          // before the first sub
          nosub_range_start=key-1; // tricky
          nosub_range_end=vo_sub->start;
//          printf("FIRST...  key=%d  end=%d  \n",key,vo_sub->start);
          vo_sub=NULL;
          return;
      }
      --current_sub;
      if(key>subs[current_sub].end && key<subs[current_sub+1].start){
          // no sub
          nosub_range_start=subs[current_sub].end;
          nosub_range_end=subs[current_sub+1].start;
//          printf("No sub... 1 \n");
          vo_sub=NULL;
          return;
      }
      printf("HEH????  ");
    } else {
      if(key<=vo_sub->end) printf("JAJJ!  "); else
      if(current_sub+1 >= subd->sub_num){
          // at the end?
          nosub_range_start=vo_sub->end;
          nosub_range_end=0x7FFFFFFF; // MAXINT
//          printf("END!?\n");
          vo_sub=NULL;
          return;
      } else
      if(key>subs[current_sub].end && key<subs[current_sub+1].start){
          // no sub
          nosub_range_start=subs[current_sub].end;
          nosub_range_end=subs[current_sub+1].start;
//          printf("No sub... 2 \n");
          vo_sub=NULL;
          return;
      }
    }
    
    mp_msg(MSGT_FIXME,MSGL_FIXME,"SUB ERROR:  %d  ?  %d --- %d  [%d]  \n",key,(int)vo_sub->start,(int)vo_sub->end,current_sub);

    vo_sub=NULL; // no sub here
}

#endif	//SK2850

#endif
