#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "config.h"

#include "ad_internal.h"
#define _ARC
#include "arc_mp3.h"

//------------------------------------------------------------------------------------------

static ad_info_t info = 
{
	"MPEG layer-2, layer-3",
	"arcmp3",
	"Nick Kurshev",
	"mpg123",
	"-*-"
};

LIBAD_EXTERN(arcmp3)


extern sh_audio_t* dec_audio_sh;
int MP3_in_container = 0;		// Raymond 2007/06/20

//------------------------------------------------------------------------------------------

int mplayer_audio_read(char *buf,int size)
{
  return demux_read_data(dec_audio_sh->ds,buf,size);
}

//------------------------------------------------------------------------------------------

static int preinit(sh_audio_t *sh)
{
  sh->audio_out_minsize=32*36*2*2; //4608;
  return 1;
}

//------------------------------------------------------------------------------------------

static int init(sh_audio_t *sh)
{
  // MPEG Audio:
  dec_audio_sh=sh; // save sh_audio for the callback:

	// Raymond 2007/06/20
	//if(sh->ds->demuxer->type == DEMUXER_TYPE_AVI || sh->ds->demuxer->type == DEMUXER_TYPE_AVI_NI)
	//Barry 2007-09-24
	if(sh->ds->demuxer->type == DEMUXER_TYPE_AVI || sh->ds->demuxer->type == DEMUXER_TYPE_AVI_NI || sh->ds->demuxer->type == DEMUXER_TYPE_AVI_NINI)
	{
		printf("MP3_in_container = 1\n");
		MP3_in_container = 1;		
	}
	
  MP3_samplerate=MP3_channels=0;

  // Mp3 Init will call decode header functionality
  MP3_Init(NULL,dec_audio_sh->a_buffer);

  if(error != NO_ERROR)
  {
    // TODO Print the error string here
     return 0;
  }
  sh->a_buffer_len=0; //MP3_DecodeFrame(sh->a_buffer,-1);
  //if(!sh->a_buffer_len) return 0; // unsupported layer/format
  sh->channels=MP3_channels; 
  sh->samplesize=2; //MP3_sampleSize ; //
  sh->samplerate= MP3_samplerate;

  	// Raymond 2007/03/23 - fixed by Barry
  	sh->i_bps=MP3_bitrate*(1000/8);	
//  MP3_bitrate = 96; //TODO need to get this information from the decoder
//  sh->i_bps=MP3_bitrate*(1000);

  MP3_PrintHeader(); // TODO Print the header information
  return 1;
}

//------------------------------------------------------------------------------------------

static void uninit(sh_audio_t *sh)
{
     MP3_Close();
}

//------------------------------------------------------------------------------------------

static int control(sh_audio_t *sh,int cmd,void* arg, ...)
{
    switch(cmd)
    {
      case ADCTRL_RESYNC_STREAM:
          MP3_DecodeFrame(NULL,-2); // resync
          MP3_DecodeFrame(NULL,-2); // resync
          MP3_DecodeFrame(NULL,-2); // resync
	  return CONTROL_TRUE;
      case ADCTRL_SKIP_FRAME:
	  MP3_DecodeFrame(NULL,-2); // skip MPEG frame
	  return CONTROL_TRUE;
    }
  return CONTROL_UNKNOWN;
}

//------------------------------------------------------------------------------------------

static int decode_audio(sh_audio_t *sh_audio,unsigned char *buf,int minlen,int maxlen)
{
   int tmp = MP3_DecodeFrame(buf,-1);

   return tmp;
}

//------------------------------------------------------------------------------------------


