
#include <stdio.h>
#include "config.h"
#include "ad_internal.h"

//-------------------------------------------------------------------------------------------

//#define INBUF_SIZE 10240
#define INBUF_SIZE ( 32 * 1024 )	// Raymond 2007/06/20
//#define SHARED_SCRATCH_MEM_SIZE (64*1024)
#define SHARED_SCRATCH_MEM_SIZE (8*1024)	// Raymond 2008/08/29

int xBuffer[2 * 1024] __attribute__((aligned(1024)));
int yBuffer[2 * 1024] __attribute__((aligned(1024)));
char inputBuffer[INBUF_SIZE];
char *pInpBuffer;
int bufusage;
char scratchMem[SHARED_SCRATCH_MEM_SIZE];
sh_audio_t* dec_audio_sh=0;

//-------------------------------------------------------------------------------------------

void shuffle_buffer(int bytesconsumed) 
{
  if (bytesconsumed) 
  {
#if 1	// Raymond 2008/06/13
	pInpBuffer += bytesconsumed;
	bufusage -= bytesconsumed;
	if(bufusage < 0)
		bufusage = 0;
	if(pInpBuffer - inputBuffer > (28 << 10) )
	{
		memcpy(inputBuffer, pInpBuffer, bufusage);
		pInpBuffer = inputBuffer;
	}
#else
    if ((bufusage -= bytesconsumed) > 0)
    {
      memcpy(inputBuffer, inputBuffer+bytesconsumed, bufusage);
    }
    else
      bufusage = 0;
#endif	
  }
}

//-------------------------------------------------------------------------------------------

int read_audio_from_demuxer(int size)
{
  char *buf;

  if (size <= bufusage) return size;

  buf = pInpBuffer + bufusage;
  size -= bufusage;

  bufusage += demux_read_data(dec_audio_sh->ds,buf,size);

  return bufusage;
}

// Raymond 2007/06/20
int read_audio_packet_from_demuxer(int size)
{
  char *buf;

  bufusage = 0;
  buf = pInpBuffer;

  bufusage += demux_read_data_pack(dec_audio_sh->ds,buf,size);

  return bufusage;
}

//-------------------------------------------------------------------------------------------

char *realloc_scratch(int size)
{
  if (size > SHARED_SCRATCH_MEM_SIZE)
  {
    fprintf (stderr, "ERROR: Shared scratch buffer is not big enough!\n");
    exit (-1);
  }

  return (scratchMem);
}

//-------------------------------------------------------------------------------------------

