

#ifndef __arc_mp3_h__
#define __arc_mp3_h__

// Undefine preprocessor macros that conflict with other codecs
#undef PERSISTENT
#undef SCRATCH
#undef PCM_SAMPLE_BITS_16
#undef PCM_SAMPLE_BITS_24
#undef SCRATCH_MEM_SIZE

#include <MPEG2-MP3Decoder/include/ittiamInterface.h>
#include <MPEG2-MP3Decoder/include/constantValues.h>

#undef OUTPUT_FORMAT
#define OUTPUT_FORMAT      PCM_SAMPLE_BITS_16

#define SAMPLES_PER_FRAME (1152)
#define OUTFRAME_SIZE     (SAMPLES_PER_FRAME * MAX_CHANNELS)
#define INFRAME_SIZE      (960 * MAX_CHANNELS)
#define INFRAME_MARKER 512

// Error handling
#define MAX_ERR_LEN 256
enum err_t {NO_ERROR, BAD_INPUT, INTERNAL_ERROR};

// Error handling
//Robert 2007-11-21 Fix GCC4.2.1 compile error
extern enum err_t     error;
//char           errorStr[MAX_ERR_LEN];

// Decoder state
//static IttiamAudioMp3Decoder_t *pObjMp3Dec;

extern void MP3_Init(void *inBuffer,void *outBuffer);
extern int MP3_Open(char *filename,int buffsize);
extern void MP3_SeekFrame(int num,int dir);
extern void MP3_SeekForward(int num);
extern int MP3_PrintTAG();
extern int MP3_DecodeFrame(unsigned char *hova,short single);
extern int MP3_FillBuffers();
extern void MP3_PrintHeader();
extern void MP3_Close();
/* public variables: */
extern int MP3_eof;        // set if EOF reached
extern int MP3_pause;      // lock playing
/* informational: */
extern int MP3_filesize;   // filesize
extern int MP3_frames;     // current frame no
extern int MP3_fpos;       // current file pos
extern int MP3_framesize;  // current framesize in bytes (including header)
extern int MP3_bitrate;    // current bitrate (kbits)
extern int MP3_samplerate; // current sampling freq (Hz)
extern int MP3_channels;
extern int MP3_sampleSize;
extern int MP3_bps;
extern int MP3_DecodedSamples;

/* player level: */
extern int  MP3_OpenDevice(char *devname);  /* devname can be NULL for default) */
extern void MP3_Play();
extern void MP3_Stop();
extern void MP3_CloseDevice();


#endif //__arc_mp3_h__

