
#include        <stdlib.h>
#include        <stdio.h>
#include        <string.h>
#include        <signal.h>
#include        <math.h>
#include "config.h"

#include "ad_internal.h"
#define _ARC
#include "arc_mp3.h"
#include <MPEG2-MP3Decoder/include/hashDefines.h>
#include "arc_common.h"

//------------------------------------------------------------------------------------------

#define INP_BUF_IDX   0
#define OUT_BUF_IDX   1

static void *pOutBuffer;

int mp3yBuffer[2 * 1024];
//Robert 2007-11-21 Fix GCC4.2.1 compile error
static char           errorStr[MAX_ERR_LEN];
enum err_t     error;

void *pMemPtr;

Word32 iBytesConsumed;
Word32 iMaxBytes;

// Memory allocation information
void    **origAddress;

// KSP bottom code is the orignal version of mp3

int MP3_frames=0;
int MP3_eof=0;
int MP3_pause=0;
int MP3_filesize=0;
int MP3_fpos=0;      // current file position
int MP3_framesize=0; // current framesize
int MP3_bitrate=0;   // current bitrate
int MP3_samplerate=0;  // current samplerate
int MP3_sampleSize = 0;
int MP3_resync=0;
int MP3_channels=0;
int MP3_bps=2;
static int MP3_bytesconsumed = 0;
int MP3_DecodedSamples = 0;
static int iFrameCount = 0;

/* informational: */
static IttiamAudioMp3Decoder_t pObjMp3Dec[1]; 

extern int MP3_in_container;		// Raymond 2007/06/20

//-------------------------------------------------------------------------------------------

static void freeMemory(IttiamAudioMp3DecoderMemInfo_t *table, int numTables, void **origAddress)
{
  int i;

  if (table != NULL)
  {
    for(i = 0; i < numTables; i++)
    {
      if(table[i].location == EXTERNAL)
      {
	free(origAddress[i]);
	origAddress[i] = NULL;
      }
    }

    free(table);
    table = NULL;
  }

  free(origAddress);
  origAddress = NULL;
}

//------------------------------------------------------------------------------------------

enum err_t decodeMp3Header(void)
{
    Word32 numBytes;
		
	// Raymond 2007/06/20
	if( MP3_in_container == 1 )
	{
		int i = 0;
		for( i = 0 ; i < 500 ; i++ )	// Raymond 2007/07/03		
		{
			numBytes = read_audio_packet_from_demuxer(12*INFRAME_SIZE);
			printf("MP3 Packet[%d] : numBytes = %d\n", i, numBytes);

			// MP3 header decoding
	    		pMemPtr = IttiamAudioMp3DecoderGetConfig(pObjMp3Dec,
	                                             AUDIO_MP3_DECODER_HEADER_DECODE,
	                                             (Word32)(numBytes));	

			if(pObjMp3Dec->strtMp3DecoderFrameInfo.bytesConsumed != -1 &&
				pObjMp3Dec->strtMp3DecoderFrameInfo.bytesConsumed <= numBytes )	// Raymond 2007/06/28
				break;			
		}
	}
	else
	{

    // Read data on input buffer from the input file
//    numBytes = read_audio_from_demuxer(4*INFRAME_SIZE);
	numBytes = read_audio_from_demuxer(8*INFRAME_SIZE);	// Raymond 2007/05/28
 
//    if(numBytes != (4*INFRAME_SIZE))
//    if(numBytes != (8*INFRAME_SIZE))	// Raymond 2007/05/28	
    if(numBytes <= (INFRAME_SIZE))	// Raymond 2007/05/29
    {
      snprintf(errorStr, MAX_ERR_LEN, "MP3 Decoder: Insufficient bytes for header decoding");
      fprintf(stderr, "\nMP3 Decoder: Insufficient bytes for header decoding %d\n\n", numBytes);
      return (BAD_INPUT);
    }

    // MP3 header decoding
    pMemPtr = IttiamAudioMp3DecoderGetConfig(pObjMp3Dec,
                                             AUDIO_MP3_DECODER_HEADER_DECODE,
                                             (Word32)(numBytes));

    if(pObjMp3Dec->strtMp3DecoderFrameInfo.bytesConsumed == -1)
    {
      while(pObjMp3Dec->strtMp3DecoderFrameInfo.bytesConsumed < 0)
      {
#if 1      // Raymond 2007/05/29		
	numBytes -= MAXFRAMESIZE;
	if(numBytes <=0)
	{
		printf("MP3 Decoder: Header decode failed\n");
		return (INTERNAL_ERROR);
	}
	shuffle_buffer(MAXFRAMESIZE);
#else	
	shuffle_buffer(4);
	numBytes -= 4;
#endif
        pMemPtr = IttiamAudioMp3DecoderGetConfig(pObjMp3Dec,
                          AUDIO_MP3_DECODER_HEADER_DECODE,
                          (Word32)(numBytes));
      }
    }
	}
	
    if(((IttiamAudioMp3DecoderFrameInfo_t *)pMemPtr)->error < 0)
    {
      snprintf(errorStr, MAX_ERR_LEN, "MP3 Decoder: Header decode failed");
      return (INTERNAL_ERROR);
    }

    MP3_bytesconsumed = pObjMp3Dec->strtMp3DecoderFrameInfo.bytesConsumed;
    MP3_sampleSize = pObjMp3Dec->strtMp3DecoderFrameInfo.samples;

    shuffle_buffer(MP3_bytesconsumed );
    
    // Get MP3 Stream sampling rate and number of channels for writing wav
    // header ( Note: In real time this info is used to configure playout )
    pMemPtr = IttiamAudioMp3DecoderGetConfig(pObjMp3Dec,
                                             AUDIO_MP3_DECODER_CONFIG,
                                             (Word32)NULL);

    MP3_samplerate = ((IttiamAudioMp3DecoderConfig_t *)pMemPtr)->defSampleRate;
    MP3_channels = ((IttiamAudioMp3DecoderConfig_t *)pMemPtr)->defNumChannels;

	// Raymond 2007/05/28 - work around first
//	if(MP3_channels == 0)
//		MP3_channels = 2;
	
	// Raymond 2007/03/23 - fixed by Barry
	MP3_bitrate = ((IttiamAudioMp3DecoderConfig_t *)pMemPtr)->defBitrate;
	
//    MP3_bitrate = ((IttiamAudioMp3DecoderConfig_t *)pMemPtr)->BitRate;
    
    // Initialization done for carrying out data read from next file
    iMaxBytes = INFRAME_SIZE;
	return (NO_ERROR);
}

//------------------------------------------------------------------------------------------

enum err_t decodeFrame(void)  //(bool *endOfFile)
{
  Word32 errorCode;
  Word32 k;
  Word8 *pubInputPtr;
  
  MP3_DecodedSamples = 0;

  read_audio_from_demuxer(INFRAME_SIZE);
//  pObjMp3Dec->strtMp3DecoderFrameInfo.iMaxInBytes = INFRAME_SIZE;

  // MP3 frame decoding
  errorCode = IttiamAudioMp3DecoderExe(pObjMp3Dec);

  iFrameCount++;

  if(errorCode < 0)
  {
    snprintf(errorStr, MAX_ERR_LEN, "MP3 Decoder: Frame decode failed (%d)", errorCode);
    return (INTERNAL_ERROR);
  }

  MP3_bytesconsumed = pObjMp3Dec->strtMp3DecoderFrameInfo.bytesConsumed;
  shuffle_buffer(MP3_bytesconsumed);

  MP3_DecodedSamples = pObjMp3Dec->strtMp3DecoderFrameInfo.samples;

  return (NO_ERROR);
}

//------------------------------------------------------------------------------------------


// Init decoder tables.  Call first, once!
void MP3_Init(void *inBuffer,void *outBuffer)
{
  
  Word32 i;
  // Allocate memory for Input/Output buffers
  pInpBuffer = inputBuffer;
  bufusage = 0;

	#if (OUTPUT_FORMAT == FMT_16BIT)
		pOutBuffer = malloc(OUTFRAME_SIZE * sizeof(short));
	#else
		pOutBuffer = malloc(OUTFRAME_SIZE * sizeof(int));
	#endif

  // Set Input buffer to feed MP3 encoded samples

  IttiamAudioMp3DecoderSetConfig(pObjMp3Dec, AUDIO_MP3_DECODER_INPBUF_ADDR, pInpBuffer, INP_BUF_IDX);

    // Set Output buffer to collect MP3 decoded samples
  IttiamAudioMp3DecoderSetConfig(pObjMp3Dec, AUDIO_MP3_DECODER_OUTBUF_ADDR, pOutBuffer, OUT_BUF_IDX);

  /*  MDT Allocation */
  IttiamAudioMp3DecoderGetConfig(pObjMp3Dec, AUDIO_MP3_DECODER_GET_NUMBER_MEMTABS, (Word32)NULL);

  pObjMp3Dec->memTable = (IttiamAudioMp3DecoderMemInfo_t *)calloc(pObjMp3Dec->numEntries, sizeof(IttiamAudioMp3DecoderMemInfo_t));

//  pObjMp3Dec->memTable = (IttiamAudioMp3DecoderMemInfo_t *)calloc(pObjMp3Dec->numEntries, sizeof(IttiamAudioMp3DecoderMemInfo_t));

  origAddress = (void **)calloc(pObjMp3Dec->numEntries, sizeof(void *));

  if ((pObjMp3Dec->memTable == NULL) || (origAddress == NULL))
  {
    snprintf(errorStr, MAX_ERR_LEN, "MP3 Decoder: Memory allocation for MDT failed");
    error = INTERNAL_ERROR;
    return;
  }

  IttiamAudioMp3DecoderSetConfig(pObjMp3Dec, AUDIO_MP3_DECODER_FILL_MEMTABS, pObjMp3Dec->memTable, (Word32)NULL);

    for(i = 0; i < pObjMp3Dec->numEntries; i++)
    {
      IttiamAudioMp3DecoderMemInfo_t *mem = &pObjMp3Dec->memTable[i];

      /* allocating and aligning memory */
      if(mem->location == EXTERNAL)
     {
        // Use scratch memory common to all codecs, but seperate persistent memory
        if (mem->memType == PERSISTENT)
          origAddress[i] = (void *)malloc(mem->size + mem->alignment);
        else
          origAddress[i] = (void *)realloc_scratch(mem->size + mem->alignment);

        if(origAddress[i] == NULL)
        {
          snprintf(errorStr, MAX_ERR_LEN, "MP3 Decoder: Memory allocation failed");
          freeMemory(pObjMp3Dec->memTable, i, origAddress);
          error = INTERNAL_ERROR;
          return;
        }

        mem->baseAddress = alignMem(origAddress[i], mem->alignment);
    }
    else if(mem->location == INTERNALX)
    {
      origAddress[i] = xBuffer;
      mem->baseAddress = alignMem(origAddress[i], mem->alignment);
    }
    else /* (mem->location == INTERNALY) */
    {
      origAddress[i] = mp3yBuffer;
      mem->baseAddress = alignMem(origAddress[i], mem->alignment);
    }
  }

  // Initialize MP3 decoder instance
  IttiamAudioMp3DecoderSetConfig(pObjMp3Dec,
                                   AUDIO_MP3_DECODER_INIT,
                                   (Word32)NULL,
                                   (Word32)NULL);

  // Set MP3 decoder number of PCM samples width
  IttiamAudioMp3DecoderSetConfig(pObjMp3Dec,
                                   AUDIO_MP3_DECODER_NUM_OF_PCM_OUTPUT_BITS,
                                   (Word32)NULL,
                                   OUTPUT_FORMAT);

  error = decodeMp3Header();
  MP3_DecodedSamples = 0;
}

//------------------------------------------------------------------------------------------

int MP3_DecodeFrame(unsigned char *hova,short single)
{
  IttiamAudioMp3DecoderSetConfig(pObjMp3Dec,
				 AUDIO_MP3_DECODER_OUTBUF_ADDR,
				 hova,
				 OUT_BUF_IDX);
 // Raymond 2008/06/13 
 IttiamAudioMp3DecoderSetConfig(pObjMp3Dec,
				 AUDIO_MP3_DECODER_INPBUF_ADDR,
				 pInpBuffer,
				 INP_BUF_IDX);

  error = decodeFrame();    
  if(error == NO_ERROR)
  {
    // TODO Print the error string here
    // memcpy(hova,pOutBuffer,sz);
    return (sizeof(Word16) * MP3_DecodedSamples);
  }
    
  return -1;
}

//------------------------------------------------------------------------------------------

void MP3_PrintHeader()
{
   static char *modes[4] = { "Stereo", "Joint-Stereo", "Dual-Channel", "Single-Channel" };
   static char *layers[4] = { "???" , "I", "II", "III" };

/*
  mp_msg(MSGT_DECAUDIO,MSGL_V,"\rMPEG %s, Layer %s, %ld Hz %d kbit %s, BPF: %ld\n",
                fr.mpeg25 ? "2.5" : (fr.lsf ? "2.0" : "1.0"),
                layers[fr.lay],freqs[fr.sampling_frequency],
    tabsel_123[fr.lsf][fr.lay-1][fr.bitrate_index],
                modes[fr.mode],fr.framesize+4);
        mp_msg(MSGT_DECAUDIO,MSGL_V,"Channels: %d, copyright: %s, original: %s, CRC: %s, emphasis: %d\n",
                fr.stereo,fr.copyright?"Yes":"No",
                fr.original?"Yes":"No",fr.error_protection?"Yes":"No",
                fr.emphasis);
                */
}

//------------------------------------------------------------------------------------------

void MP3_Close(void)
{
  freeMemory(pObjMp3Dec->memTable, pObjMp3Dec->numEntries, origAddress);
}

//------------------------------------------------------------------------------------------
