#ifndef _VBUF_H_
#define _VBUF_H_

#ifdef	__cplusplus
extern "C" {
#endif

/* allocate a buffer for video. Block if 
   no buffer is yet available */
int vbuf_alloc(void);

/* free buffer */
void vbuf_free(int v);

/* send buffer to display queue */
void vbuf_send(int v);

/* return a bitmask of available buffers */
unsigned vbuf_avail(void);

// Set decoder buffer resolution - Raymond 2006/12/27
int SetDecBufferResolution(int w, int h);

int vbuf_dec_alloc(void);
void vbuf_dec_free(int v);

int vbuf_scale_alloc(void);
void vbuf_scale_free(int v);
void vbuf_scale_send(int v);

// Raymond 2007/04/26
unsigned char * get_bufN_Y(int n);
unsigned char * get_bufN_U(int n);
unsigned char * get_bufN_V(int n);
unsigned char * get_dec_yuv_bufN(int n);

//for scalar Barry 2007-05-11
void vbuf_scalar_start(int n);

#ifdef	__cplusplus
};
#endif

#endif
