/*
      //------------------------------------------------------------------------
      //
      //                  S K Y M E D I   P R O P R I E T A R Y
      //
      //          COPYRIGHT (c)   2007 BY SKYMEDI CORPORATION TAIWAN.
      //                   --  ALL RIGHTS RESERVED  --
      //       SKYMEDI Confidential; Need to Know only.
      //       Protected as an unpublished work.
      //
      //       The computer program listings, specifications and documentation
      //       herein are the property of SKYMEDI CORPORATION and shall not be
      //       reproduced, copied, disclosed, or used in whole or in part for
      //       any reason without the prior express written permission of
      //       SKYMEDI CORPORATION.
      //
      //          File Name:        skysyscalls.h
      //
      //          Author:           Jinn
      //
      //          Created:          2, June 2008
      //
      //          Revision:         1.00
      //
      //------------------------------------------------------------------------
 */

#ifndef __SKYSYSCALLS_H__
#define __SKYSYSCALLS_H__

#define _syscall0(type, name)                               \
type name(void)                                             \
{                                                           \
  long __res;                                               \
  __asm__ __volatile__ ("mov  r8, %1\n\t"                   \
               "trap0 \n\t"                                 \
               "nop    \n\t"                                \
                        "nop    \n\t"                       \
                     "mov     %0, r0"                       \
               : "=r" (__res)                               \
               : "i" (__NR_##name)                          \
               : "cc", "r0", "r8");                         \
  if ((unsigned long)(__res) >= (unsigned long)(-125)) {    \
    errno = -__res;                                         \
    __res = -1;                                             \
  }                                                         \
  return (type)__res;                                       \
}

#define _syscall1(type, name, atype, a)                     \
type name(atype a)                                          \
{                                                           \
  long __res;                                               \
  __asm__ __volatile__ ("mov  r0, %2\n\t"                   \
               "mov r8, %1\n\t"                             \
               "trap0 \n\t"                                 \
               "nop    \n\t"                                \
                        "nop    \n\t"                       \
                     "mov     %0, r0"                       \
               : "=r" (__res)                               \
               : "i" (__NR_##name),                         \
                 "r" ((long)a)                              \
               : "cc", "r0", "r8");                         \
  if ((unsigned long)(__res) >= (unsigned long)(-125)) {    \
    errno = -__res;                                         \
    __res = -1;                                             \
  }                                                         \
  return (type)__res;                                       \
}

#define _syscall2(type, name, atype, a, btype, b)           \
type name(atype a, btype b)                                 \
{                                                           \
  long __res;                                               \
  __asm__ __volatile__ ("mov  r1, %3\n\t"                   \
               "mov r0, %2\n\t"                             \
               "mov r8, %1\n\t"                             \
               "trap0 \n\t"                                 \
               "nop    \n\t"                                \
                        "nop    \n\t"                       \
                     "mov     %0, r0"                       \
               : "=r" (__res)                               \
               : "i" (__NR_##name),                         \
                 "r" ((long)a),                             \
                 "r" ((long)b)                              \
               : "cc", "r0", "r1", "r8");                   \
  if ((unsigned long)(__res) >= (unsigned long)(-125)) {    \
    errno = -__res;                                         \
    __res = -1;                                             \
  }                                                         \
  return (type)__res;                                       \
}
#define _syscall3(type, name, atype, a, btype, b, ctype, c) \
type name(atype a, btype b, ctype c)                        \
{                                                           \
  long __res;                                               \
  __asm__ __volatile__ (                                    \
               "ld  r2, %4\n\t"                             \
               "mov r1, %3\n\t"                             \
               "mov r0, %2\n\t"                             \
               "mov r8, %1\n\t"                             \
               "trap0 \n\t"                                 \
               "nop    \n\t"                                \
                        "nop    \n\t"                       \
                     "mov     %0, r0"                       \
               : "=r" (__res)                               \
               : "i" (__NR_##name),                         \
                 "r" ((long)a),                             \
                 "r" ((long)b),                             \
                 "m" ((long)c)                              \
               : "cc", "r0", "r1", "r2", "r8");             \
  if ((unsigned long)(__res) >= (unsigned long)(-125)) {    \
    errno = -__res;                                         \
    __res = -1;                                             \
  }                                                         \
  return (type)__res;                                       \
}

#define _syscall4(type, name, atype, a, btype, b, ctype, c, dtype, d) \
type name(atype a, btype b, ctype c, dtype d)               \
{                                                           \
  long __res;                                               \
  __asm__ __volatile__ ("mov  r3, %5\n\t"                   \
               "mov r2, %4\n\t"                             \
               "mov r1, %3\n\t"                             \
               "mov r0, %2\n\t"                             \
               "mov r8, %1\n\t"                             \
               "trap0 \n\t"                                 \
                        "nop    \n\t"                       \
                        "nop    \n\t"                       \
                     "mov     %0, r0"                       \
               : "=r" (__res)                               \
               : "i" (__NR_##name),                         \
                 "r" ((long)a),                             \
                 "r" ((long)b),                             \
                 "r" ((long)c),                             \
                 "r" ((long)d)                              \
               : "cc", "r0", "r1", "r2", "r3",              \
                 "r8");                                     \
  if ((unsigned long)(__res) >= (unsigned long)(-125)) {    \
    errno = -__res;                                         \
    __res = -1;                                             \
  }                                                         \
  return (type)__res;                                       \
}

#define _syscall5(type, name, atype, a, btype, b, ctype, c, dtype, d, etype, e) \
type name(atype a, btype b, ctype c, dtype d, etype e)      \
{                                                           \
  long __res;                                               \
  __asm__ __volatile__ ("mov  r4, %6\n\t"                   \
               "mov r3, %5\n\t"                             \
               "mov r2, %4\n\t"                             \
               "mov r1, %3\n\t"                             \
               "mov r0, %2\n\t"                             \
               "mov r8, %1\n\t"                             \
               "trap0 \n\t"                                 \
                        "nop    \n\t"                       \
                        "nop    \n\t"                       \
               "mov %0, r0"                                 \
               : "=r" (__res)                               \
               : "i" (__NR_##name),                         \
                 "r" ((long)a),                             \
                 "r" ((long)b),                             \
                 "r" ((long)c),                             \
                 "r" ((long)d),                             \
                 "r" ((long)e)                              \
               : "cc", "r0", "r1", "r2", "r3",              \
                 "r4", "r8");                               \
  if ((unsigned long)(__res) >= (unsigned long)(-125)) {    \
    errno = -__res;                                         \
    __res = -1;                                             \
  }                                                         \
  return (type)__res;                                       \
}

#define __NR_u32_readphy      226  /* jinn - 20080527 - new for 2851 */
#define __NR_u32_writephy     227  /* jinn - 20080527 - new for 2851 */
#define __NR_bit_readphy      228  /* jinn - 20080527 - new for 2851 */
#define __NR_bit_writephy     229  /* jinn - 20080527 - new for 2851 */
#define __NR_get_ir_val       230  /* jinn - 20080527 - new for 2851 */
#define __NR_skydma           231  /* jinn - 20080613 - new for 2851 */
#define __NR_set_ir_status    232  /* jinn - 20080613 - new for 2851 */
#define __NR_exchange_msg     233  /* jinn - 20080613 - new for 2851 */

/* control register definition */
#define GIOP_DIR                             0xC1FC0000

#define GIOP_DATA                            0xC1FC0004

#define EIOP_DIR                             0xC1FC0008

#define EIOP_DATA                            0xC1FC000C

#define EIOP_INT_TYPE                        0xC1FC0010

#define EIOP_INT_STATUS                      0xC1FC0014

#define GIOP_WR_EN                           0xC1FC0018

#define EIOP_INT_WE_EN                       0xC1FC001C

#define GIOH_DIR                             0xC1FC0020

#define GIOH_DATA                            0xC1FC0024

#define GIOH_WR_EN_DATA                      0xC1FC0028

#define SKYREG_DBP_STS                       0xC0FC1880                         /* Debug Port Status */
        #define CARD_WAS_CHANGED             0x00000001
        #define CARD_NOT_CHANGE              0xFFFFFFFE
        #define IR_DETECT                    0x00000002
        #define IR_NOT_DETECT                0xFFFFFFFD
        #define FUSB202_CABLE_IN             0x00000004
        #define FUSB202_CABLE_OUT            0xFFFFFFFB
        #define OTGUSB_CABLE_IN              0x00000008
        #define OTGUSB_CABLE_OUT             0xFFFFFFF7
        #define DMA0_USE                     0x00000010
        #define DMA0_NOT_USE                 0xFFFFFFEF
        #define DMA1_USE                     0x00000020
        #define DMA1_NOT_USE                 0xFFFFFFDF
        #define DMA2_USE                     0x00000040
        #define DMA2_NOT_USE                 0xFFFFFFBF
        #define SIMD_USE                     0x00000080
        #define SIMD_NOT_USE                 0xFFFFFF7F

#define DMA_CH0                              0
#define DMA_CH1                              1
#define DMA_CH2                              2

#define NOT_PRINT_DEBUG_MESSAGE              0
#define PRINT_DEBUG_MESSAGE                  1

/*
 * system call - macro definition
 */
#define MSG_QUEUE_SIZE             64
#define MSG_MAGIC_NUMBER           0xB0322CDA

#define MSG_CMD_OK                 0
#define MSG_CMD_FAIL               MSG_MAGIC_NUMBER

#define READ_MSG                   0x00000001
#define WRITE_MSG                  0x00000002
#define CLEAR_ALL_MSG              0x00000004

#define VALID_TYPE_MASK            0xFFFF0000
#define TYPE_DONT_CARE             0x00000000
#define REMOVE_MSG_AFTER_READ      0x00010000
#define NOT_CHANGE_MSG_QUEUE_DATA  0x00020000
#define FORCED_WRITE_MSG_2_QUEUE   0x00040000
#define OVERWRITE_MSG              0x00080000

//Barry 2008-08-18
#define IR_POOL						0x00000000
#define VIDEOTIME_ONOFF_POOL		0x00000001
#define MPLAYER_DURATION_POOL		0x00000002
#define MPLAYER_TIME_POOL			0x00000003
#define MPLAYER_STATUS_POOL		0x00000004

/*
 * Declaration
 */
unsigned int get_ir_val( void );
unsigned int set_ir_status( unsigned int _iType );
unsigned int u32_readphy( volatile unsigned int* _iPhyAdd);
unsigned int u32_writephy( volatile unsigned int* _iPhyAdd, unsigned int _iVal );
unsigned int bit_readphy( volatile unsigned int* _iPhyAdd, unsigned int _iMask );
unsigned int bit_writephy( volatile unsigned int* _iPhyAdd, unsigned int _iMask, unsigned int _iVal );
unsigned int exchange_msg( unsigned int _iCmd, unsigned int* _piData, unsigned int _iType );
unsigned int skydma( unsigned int _iChannel, unsigned int _iDest, unsigned int _iSrc, unsigned int _iLength, unsigned int _iDebug );

//Barry 2008-08-18
unsigned long syscall_get_ir( void );
void DMA_COPY( unsigned int _iDest, unsigned int _iSrc, unsigned int _iLength );
unsigned int syscall_get_video_time_onoff( void );
void syscall_set_mplayer_duration( unsigned int _iData );
void syscall_set_mplayer_time( unsigned int _iData );
void syscall_set_mplayer_status( unsigned int _iData );
void syscall_clear_mplayer_duration( void );
void syscall_clear_mplayer_time( void );

#endif // __SKYSYSCALLS_H__