//Barry 2008-05-29
#include "textutil.h"
#include<string.h>

//FONT_DB *g_pFontDB_Default = NULL;
FONT_DB *g_pFontDB_Local= NULL;
///080115 iconv
//FONT_DB *g_pFontDB_Unicode = NULL;
iconv_t g_cd_utf8_2_local = (iconv_t)-1;
iconv_t g_cd_utf8_2_ucs2 = (iconv_t)-1;
iconv_t g_cd_local_2_ucs2 = (iconv_t)-1;
/// 

Uint16 GetFontStringWidth(FONT_DB *pFontDB, BYTE *str)
{
	if (!pFontDB || !str) return 0;
	WORD Code;
	WORD TrueCharWidth, TrueCharHeight;
	bool bSuccess = true;
	Uint16 RetWidth = 0;

	///080118
	if (pFontDB->CharSet == UCS2_CODING)
	{
		return GetFontStringWidthW(pFontDB, str, 0);
	}
	///

	while (*str && bSuccess)
	{
		switch (pFontDB->CharSet)
		{
		case CHINESEBIG5_CHARSET:
		case GB2312_CHARSET:
		case HANGUL_CHARSET:
			if (*str < 0x80)	//b
			{
				Code = (WORD)(*str);
				str++;
			}
			else if (*(str+1))	//
			{
				Code = ((WORD)(*str) << 8) + (WORD)(*(str+1));
				str += 2;
			}
			else
			{
				bSuccess = false;
			}			
			break;
		case SHIFTJIS_CHARSET:
			if (  *str < 0x80						//b
				||
				  (*str >= 0xA1 && *str <= 0xDF)	//bΤ
			   )
			{
				Code = (WORD)(*str);
				str++;
			}
			else if (*(str+1))						//Τ
			{
				Code = ((WORD)(*str) << 8) + (WORD)(*(str+1));
				str += 2;
			}
			else
			{
				bSuccess = false;
			}
			break;
		default:	//bλyt
			Code = (WORD)(*str);
			str++;
			break;
		}

		if (!bSuccess) break;

		//bufferNULL, u^Ǧre
		if (!Draw_Char_Image(pFontDB, Code, NULL, &TrueCharHeight, &TrueCharWidth))
		{
			bSuccess = false;
			break;
		}

		RetWidth += TrueCharWidth;
	}

	if (!bSuccess )
		return 0;
	else
		return RetWidth;
}
//------------------------------------------------------------------------------------------------
///080118
Uint16 GetFontStringWidthW(FONT_DB *pFontDB, BYTE *str, int UseUTF)
{
	if (!pFontDB || !str) return 0;

	//return
	Uint16 RetWidth = 0;

	//for iconv
	BYTE strtemp[LEN_XXL];
	memset(strtemp, 0, LEN_XXL);
	iconv_t cd = (iconv_t)-1;
	char *inbuf = &str[0];
	char *outbuf = &strtemp[0];
	BYTE *strData = str;
	size_t inbytesleft, outbytesleft, non_rev;
	//int len = 0;

	//temp
	WORD Code;
	Uint16 w, h;

	if (  UseUTF == 8						//Yw]utf-8
		||
		  (UseUTF == -8 && isUTF8(str) > 0)	//βqutf-8 (iq)
	   )
	{
		if (pFontDB->CharSet == UCS2_CODING)
		{
				cd = g_cd_utf8_2_ucs2;
		}
		else
		{
///080514
#ifdef FONTDB_PRIVATE_CODEPAGE
			if (  pFontDB->cd_utf8_2_local != (iconv_t)-1
				&&
				  pFontDB->bUsePrivateCodepage
			   )
				cd = pFontDB->cd_utf8_2_local;
			else
#endif
///
				cd = g_cd_utf8_2_local;
		}
	}
	else if (UseUTF != 16)
	{
		if (pFontDB->CharSet == UCS2_CODING)	//localsXucs2
		{
///080514
#ifdef FONTDB_PRIVATE_CODEPAGE
			if (  pFontDB->cd_local_2_ucs2 != (iconv_t)-1
				&&
				  pFontDB->bUsePrivateCodepage
			   )
				cd = pFontDB->cd_local_2_ucs2;
			else
#endif
///
				cd = g_cd_local_2_ucs2;
		}
	}

	if (cd != (iconv_t)-1)
	{
		inbytesleft = strlenW(str, UseUTF);
		outbytesleft = LEN_XXL;
#ifdef SHARE_CODE_CONV
		CodeConv_Convert(cd, inbuf, inbytesleft, outbuf, outbytesleft);
#else
		non_rev = iconv(cd, (const char**)&inbuf, &inbytesleft, &outbuf, &outbytesleft);
#endif
		//len = (int)LEN_XL - outbytesleft;
		strData = strtemp;
	}

	//OrX
	if (pFontDB->CharSet == UCS2_CODING)	//UCS2 CӦr2BYTE
	{
		//UCS20x0000
		while (0x0000 != (Code = *((WORD*)strData)))
		{
			if (Draw_Char_Image(pFontDB, Code, NULL, &h, &w))
			{
				RetWidth += w;
			}
			strData += 2;
		}
	}
	else	//qsX,CӦr1~2BYTE
	{
		Code = 0;
		while (*strData)
		{
			Code |= (WORD)(*strData);
			if (Draw_Char_Image(pFontDB, Code, NULL, &h, &w))
			{
				RetWidth += w;
				Code = 0;
			}
			else
			{
				Code <<= 8;
			}
			strData++;
		}
	}

	return RetWidth;
}
///
//------------------------------------------------------------------------------------------------
///080128
Uint16 strlenW(BYTE *str, int UseUTF)
{
	if (!str) return 0;

	WORD *pStr;
	Uint16 len = 0;
	
	if (UseUTF == 16)	//0x0000ܦr굲
	{
		pStr = (WORD*)str;
		while (*pStr != 0x0000)
		{
			len++;
			pStr++;
		}
		return len;
	}
	else if (UseUTF < 16)	//utf80
	{
		return strlen(str);
	}
	else	//榡
	{
		return 0;
	}
}
///
//------------------------------------------------------------------------------------------------
#ifdef USE_FONTAA
bool FillFontAAMap(BYTE* pImage, int width, int height, int nBPL)
{
	int i, j;
	BYTE *pRowImg, *pI;
	BYTE nNeiborLR, nNeiborUD;
	int height_ = height - 2;
	int width_ = width - 2;
	pRowImg = pImage + nBPL + 1;
	for (i=0; i<height_; i++)
	{
		pI = pRowImg;
		for (j=0; j<width_; j++)
		{
			if (   *pI == 0		//I
			    &&
				 (*(pI-1) == 1 || *(pI+1) == 1)				//kI
			    &&
				 (*(pI-nBPL) == 1 || *(pI+nBPL) == 1)		//WU]I
			   )
			{
				*pI = 2;
			}
			/*
				nNeibor = 0;
				if (*(pI-1) == 1) nNeibor |= 0x01;		//
				if (*(pI+1) == 1) nNeibor |= 0x02;		//k
				if (*(pI-nBPL) == 1) nNeibor |= 0x04;	//W
				if (*(pI+nBPL) == 1) nNeibor |= 0x08;	//U
				if (  (nNeibor & 0x05) == 0x05
				    ||
				      (nNeibor & 0x06) == 0x06
				    ||
				      (nNeibor & 0x09) == 0x09
				    ||
				      (nNeibor & 0x0A) == 0x0A
				   )
				{
					*pI = 2;
					//if (nNeibor >= 2) *pI = nNeibor;
				}		
			}
			*/
			pI++;
		}
		pRowImg += nBPL;
	}
	return true;
}
#endif
//------------------------------------------------------------------------------------------------
#if 0	//Barry 2008-05-29
Uint16 FontTextOut(FONT_DB *pFontDB, Uint16 *RGBFrame, int x, int y, BYTE *str, Uint16 color)
{
	return FontTextOutAlign(pFontDB, RGBFrame, OUTPUT_XRES, x, y, 0, str, color);
}
#endif
//------------------------------------------------------------------------------------------------
#if 0	//Barry 2008-05-29
Uint16 FontTextOutFormat(FONT_DB *pFontDB, Uint16 *RGBFrame, int x, int y, BYTE *str, Uint16 color, Uint32 nFormat)
{
	Uint16 StrWidth, StrWidth_2;
	Uint16 MaxWidth = 0;		//w]e
	
	if (nFormat & DT_CENTER)
	{
		StrWidth = GetFontStringWidth(pFontDB, str);
		StrWidth_2 = StrWidth / 2;
		if (x < StrWidth_2)
			x = 0;
		else
			x -= StrWidth_2;
		MaxWidth = 0;
	}
	else if (nFormat & DT_RIGHT)
	{
		MaxWidth = x;
		StrWidth = GetFontStringWidth(pFontDB, str);
		if (x < StrWidth)
			x = 0;
		else
			x -= StrWidth;
		MaxWidth = MaxWidth - x + 1;
	}

	return FontTextOutAlign(pFontDB, RGBFrame, OUTPUT_XRES, x, y, MaxWidth, str, color);
}
#endif
//------------------------------------------------------------------------------------------------
#if 0	//Barry 2008-05-29
///080128
Uint16 FontTextOutFileName(FONT_DB *pFontDB, BYTE *str, 
						   int UseUTF,
						   Uint8 bShowPath,
						   Uint16 color,
						   Uint16 *RGBFrame, Uint16 FrameWidth,
						   Uint16 x, Uint16 y, Uint16 w, Uint16 h)
{
	if (!pFontDB || !str) return 0;

	Uint16 TotalWidth;
	//YצXzh`
	if (  bShowPath
		&&
		  (  w == 0
		   ||
		    ((TotalWidth = GetFontStringWidthW(pFontDB, str, UseUTF)) <= w)
		  )
	   )
	{
		return FontTextOutW(pFontDB, str, UseUTF, color, RGBFrame, FrameWidth, x, y, w, h);
	}

	///080429 DUCS2ܸ|P_bo̰
	if (!bShowPath && UseUTF != 16)
	{
		char *pSlash = strrchr(str, '/');
		if (pSlash) str = pSlash + 1;
	}
	///

	//for iconv
	BYTE strtemp[LEN_XXL];
	memset(strtemp, 0, LEN_XXL);
	iconv_t cd = (iconv_t)-1;
	char *inbuf = &str[0];
	char *outbuf = &strtemp[0];
	BYTE *strData = str;
	size_t inbytesleft, outbytesleft, non_rev;
	//int len = 0;

	//temp
	//WORD *codearray = (WORD*)strtemp;
	WORD codearray[LEN_XL];
	memset(codearray, 0, LEN_XL*sizeof(WORD));
	WORD Code, *pCode, nCode;
	WORD *pStart, *pFileName, *pExt;

	if (  UseUTF == 8						//Yw]utf-8
		||
		  (UseUTF == -8 && isUTF8(str) > 0)	//βqutf-8 (iq)
	   )
	{
		if (pFontDB->CharSet == UCS2_CODING)
		{
				cd = g_cd_utf8_2_ucs2;
		}
		else
		{
///080514
#ifdef FONTDB_PRIVATE_CODEPAGE
			if (  pFontDB->cd_utf8_2_local != (iconv_t)-1
				&&
				  pFontDB->bUsePrivateCodepage
			   )
				cd = pFontDB->cd_utf8_2_local;
			else
#endif
///
				cd = g_cd_utf8_2_local;
		}
	}
	else if (UseUTF != 16)
	{
		if (pFontDB->CharSet == UCS2_CODING)	//localsXucs2
		{
///080514
#ifdef FONTDB_PRIVATE_CODEPAGE
			if (  pFontDB->cd_local_2_ucs2 != (iconv_t)-1
				&&
				  pFontDB->bUsePrivateCodepage
			   )
				cd = pFontDB->cd_local_2_ucs2;
			else
#endif
///
				cd = g_cd_local_2_ucs2;
		}
	}

	if (cd != (iconv_t)-1)
	{
		inbytesleft = strlenW(str, UseUTF);
		outbytesleft = LEN_XXL - 8;
#ifdef SHARE_CODE_CONV
		CodeConv_Convert(cd, inbuf, inbytesleft, outbuf, outbytesleft);
#else
		non_rev = iconv(cd, (const char**)&inbuf, &inbytesleft, &outbuf, &outbytesleft);
#endif
		//len = (int)LEN_XXL - outbytesleft;
		strData = strtemp;
	}

	//OrX
	nCode = 0;
	pCode = &codearray[4];	//OdT'.'
	if (pFontDB->CharSet == UCS2_CODING)	//UCS2 CӦr2BYTE
	{
		//UCS20x0000
		while (0x0000 != (Code = *((WORD*)strData)))
		{
            if (Code_Cover(pFontDB, Code))
			{
				*pCode++ = Code;
				nCode++;
			}
			strData += 2;
		}
		*pCode = 0x0000;	//0
	}
	else	//qsX,CӦr1~2BYTE
	{
		Code = 0;
		while (*strData)
		{
			Code |= (WORD)(*strData);
			if (Code_Cover(pFontDB, Code))
			{
				*pCode++ = Code;
				nCode++;
				Code = 0;
			}
			else if (  Code > 0x00FF	//byte@_٬OAhոլ
					 &&
					   Code_Cover(pFontDB, (Code&0x00FF))
					)
			{
				*pCode++ = (Code&0x00FF);
				nCode++;
				Code = 0;
			}
			else
			{
				Code <<= 8;
			}
			strData++;
		}
		*pCode = 0x0000;	//0
	}
	if (nCode == 0) return 0;

	//Yr
	//1.ɦW}YPɦW}Y
	pStart = &codearray[4];
	pFileName = pStart + nCode;		//Filename쵲Ŧr
	pExt = pFileName;				//ɦW쵲Ŧr
	Uint16 FileNameWidth = 0;		//pثee
	//Uint16 ExtWidth = 0;
	Uint16 tempw, temph;
	Uint16 DotWidth = GetFontStringWidthW(pFontDB, "...", 0);
	Uint16 TildeWidth = GetFontStringWidthW(pFontDB, "~", 0);

	pCode = pStart + nCode - 1;	//qe
	while (pCode >= pStart && *pCode != 0x002F)	//I'/'N
	{
		//
		if (Draw_Char_Image(pFontDB, *pCode, NULL, &temph, &tempw))
		{
			FileNameWidth += tempw;
	
			if (*(pFileName = pCode) == 0x002E)	//'.'
			{
				if (!(*pExt))
				{
					pExt = pCode;	//ɦW
					//ExtWidth = FileNameWidth;
				}
			}
		}
		pCode--;
	}

	if (!bShowPath)
	{
		pStart = pFileName;
		TotalWidth = FileNameWidth;
	}

	//2.LɮצWٳBz, BzL᪺rꬰpFileName
	if (w != 0)
	{
		if (*pFileName && FileNameWidth > w)	//OɦWwgWLe
		{
			pCode = pExt - 1;	//qɦWe@Ӧr}l
			while (pCode > pFileName)	//DɦWܤ֫Od@Ӧr
			{
				if (Draw_Char_Image(pFontDB, *pCode, NULL, &temph, &tempw))
				{
					FileNameWidth -= tempw;
					if (FileNameWidth + TildeWidth <= w)
					{
						*pCode++ = 0x007E;	//'~'
						//ɦWpCodem
						while (*pExt)
						{
							*pCode++ = *pExt++;
						}
						*pCode = 0x0000;	//r굲
						break;
					}
				}
				pCode--;
			}
		}
		else	//|W٤ӪA"..."Y|W١AYɦW
		{
			pCode = pStart;
			while (pCode < pFileName)
			{
				Draw_Char_Image(pFontDB, *pCode, NULL, &temph, &tempw);
				TotalWidth -= tempw;
				if (TotalWidth + DotWidth <= w)
				{
					//eWT'.'
					*pCode-- = 0x002E;	//'.'
					*pCode-- = 0x002E;
					*(pFileName = pCode) = 0x002E;
					break;
				}
				pCode++;
			}
		}
	}

	//3.YOunicoderAh²ƬMultiByter
	if (pFontDB->CharSet != UCS2_CODING)
	{
		BYTE *pChar = (BYTE*)pFileName;
		pCode = pFileName;
		while (Code = *pCode)
		{			
			if (Code > 0x00FF)
				*pChar++ = (BYTE)(Code >> 8);
			*pChar++ = (BYTE)(Code & 0x00FF);
			pCode++;
		}
		*pChar = '\0';	//0
	}

	//ܳBzr
	return FontTextOutW(pFontDB, (BYTE*)pFileName,
						(pFontDB->CharSet==UCS2_CODING ? 16 : 0),
						color,
                        RGBFrame, FrameWidth, x, y, w, h);
}
///
#endif
//------------------------------------------------------------------------------------------------
#ifdef BUILD_SK2851		//Barry 2008-06-18
Uint16 FontTextOutAlign(FONT_DB *pFontDB, Uint8 *RGBFrame, Uint16 FrameWidth, int x, int y, int MaxWidth, BYTE *str, Uint8 color)
#else
Uint16 FontTextOutAlign(FONT_DB *pFontDB, Uint16 *RGBFrame, Uint16 FrameWidth, int x, int y, int MaxWidth, BYTE *str, Uint16 color)
#endif
{
	bool bSuccess = true;
	WORD CharHeight, BufferWidthAlign, TrueCharWidth, TrueCharHeight;
	BYTE *ImageBuffer;
	WORD Code;
#ifdef BUILD_SK2851		//Barry 2008-06-18
	char *pStartFrame, *pRowFrame, *pFrame;
#else
	WORD *pStartFrame, *pRowFrame, *pFrame;
#endif
	BYTE *pRowChar, *pChar;
	int i, j, LenX, LenY;
	WORD RightBound;
	Uint16 RetWidth = 0;
#ifdef USE_FONTAA	//Ͽ
	BYTE B, G, R;
	///070824
	Uint16 YF, YB, YM;
	///
#endif

	///080118
	if (  pFontDB	//080414
		&&
		  pFontDB->CharSet == UCS2_CODING
		)
	{
		return FontTextOutW(pFontDB, str, 0,//ϥutf-8
							color,
							RGBFrame, FrameWidth,
							x, y, MaxWidth, 0);
	}
	///

	if (!RGBFrame || !pFontDB || !str || x<0 || y<0 || x>=FrameWidth)// || y>=OUTPUT_YRES)	//Barry 2008-05-29
	{
		return 0;
	}

	CharHeight = pFontDB->FontSize;

	BufferWidthAlign = pFontDB->FontSize*2;

	//ImageBuffer = (BYTE*)malloc(CharHeight * BufferWidthAlign);
	ImageBuffer = (BYTE*)salloc(CharHeight * BufferWidthAlign);		//Barry 2008-05-29
	if (!ImageBuffer)
	{
		return 0;
	}

	RightBound = FrameWidth;
	
	if (MaxWidth > 0 && x + MaxWidth < RightBound)
	{
		RightBound = x + MaxWidth;
	}

	pStartFrame = RGBFrame + y*FrameWidth + x;

	while (*str && bSuccess)
	{
		Code = 0;
		switch (pFontDB->CharSet)
		{
		case CHINESEBIG5_CHARSET:
		case GB2312_CHARSET:
		case HANGUL_CHARSET:
			if (*str < 0x80)	//b
			{
				Code = (WORD)(*str);
				str++;
			}
			else if (*(str+1))	//
			{
				Code = ((WORD)(*str) << 8) + (WORD)(*(str+1));
				str += 2;
			}
			else
			{
				///070803 ݤť
				Code = 0x20;
				str++;
				//bSuccess = false;
				///
			}			
			break;
		case SHIFTJIS_CHARSET:
			if (  *str < 0x80						//b
				||
				  (*str >= 0xA1 && *str <= 0xDF)	//bΤ
			   )
			{
				Code = (WORD)(*str);
				str++;
			}
			else if (*(str+1))						//Τ
			{
				Code = ((WORD)(*str) << 8) + (WORD)(*(str+1));
				str += 2;
			}
			else
			{
				///070803 ݤť
				Code = 0x20;
				str++;
				//bSuccess = false;
				///
			}
			break;
		default:	//bλyt
			Code = (WORD)(*str);
			str++;
			break;
		}

		//if (!bSuccess) break;

		if (!Draw_Char_Image(pFontDB, Code, ImageBuffer, /*BufferWidthAlign, */&TrueCharHeight, &TrueCharWidth))
		{
			///070803 SrNeť
			if (!Draw_Char_Image(pFontDB, 0x20, ImageBuffer, /*BufferWidthAlign, */&TrueCharHeight, &TrueCharWidth))
				continue;
			//bSuccess = false;
			//break;
			///

		}

		LenX = TrueCharWidth;
		LenY = TrueCharHeight;
		if (x + TrueCharWidth > RightBound)
		{
			LenX = RightBound - x;
		}
#if 0	//Barry 2008-05-29
		if (y + TrueCharHeight > OUTPUT_YRES)
		{
			LenY = OUTPUT_YRES - y;
		}
#endif

		if (LenX < 0 || LenY < 0)
		{
			//bSuccess = false;
			break;
		}

#ifdef USE_FONTAA	//nϿϰ2
		if (pFontDB->bUseFontAA)
		{
			FillFontAAMap(ImageBuffer, TrueCharWidth, TrueCharHeight, TrueCharWidth);
		}
#endif

		pRowFrame = pStartFrame;
		pRowChar = ImageBuffer;

///070824
#ifdef USE_FONTAA
		if (pFontDB->bUseFontAA)
		{
///
			for (i=0; i<LenY; i++)
			{
				pFrame = pRowFrame;
				pChar = pRowChar;
				for (j=0; j<LenX; j++)
				{ 
					if (*pChar == 1)
					{
						*pFrame = color;
					}
					else if (*pChar >= 2)
					{
						///
						B = (color & 0x1F);
						G = (color>>5) & 0x1F;
						R = (color>>10) & 0x1F;
						YF = (Uint16)B + (Uint16)G + (Uint16)R;
						//YF = ((Uint16)B<<1) + ((Uint16)G)*9 + ((Uint16)R)*5;
						YB = ((*pFrame) & 0x1F) + (((*pFrame)>>5) & 0x1F) + (((*pFrame)>>10) & 0x1F);
						//YB = (((*pFrame) & 0x1F)<<1) + (((*pFrame)>>5) & 0x1F)*9 + (((*pFrame)>>10) & 0x1F)*5;
						YM = (YF + YB) >> 1;
		
						if (YF <= YM)		//ݭnG
						{
							if (YF > 0)
							{
								B = (Uint8)((Uint16)B * YM / YF);
								G = (Uint8)((Uint16)G * YM / YF);
								R = (Uint8)((Uint16)R * YM / YF);
								if (B < 32) ; else B = 31;
								if (G < 32) ; else G = 31;
								if (R < 32) ; else R = 31;
							}
							else
							{
								B = G = R = (Uint8)(YM/3);
							}
						}
						else				//YF > YMݭnCG
						{
							B = (Uint8)((Uint16)B * YM / YF);
							G = (Uint8)((Uint16)G * YM / YF);
							R = (Uint8)((Uint16)R * YM / YF);							
						}
						///

						/*
						B = ((color & 0x1F) + ((*pFrame) & 0x1F)) >> 1;
						G = (((color>>5) & 0x1F) + (((*pFrame)>>5) & 0x1F)) >> 1;
						R = (((color>>10) & 0x1F) + (((*pFrame)>>10) & 0x1F)) >> 1;
						*/
						
						///070912 OdMSB
						*pFrame &= 0x8000;
						*pFrame |= (((Uint16)R)<<10) | (((Uint16)G)<<5) | ((Uint16)B);
						//*pFrame = (((Uint16)R)<<10) | (((Uint16)G)<<5) | ((Uint16)B);
						///
					} 
					pFrame++;
					pChar++;
				}
				pRowFrame += FrameWidth;
				pRowChar += TrueCharWidth;/*BufferWidthAlign*/
			}
		}
		else
#endif
		{
			for (i=0; i<LenY; i++)
			{
				pFrame = pRowFrame;
				pChar = pRowChar;
				for (j=0; j<LenX; j++)
				{
					if (*pChar)
					{
						*pFrame = color;
					}
					pFrame++;
					pChar++;
				}
				pRowFrame += FrameWidth;
				pRowChar += TrueCharWidth;/*BufferWidthAlign*/
			}
		}
		
		RetWidth += LenX;
		
		pStartFrame += TrueCharWidth;
		x += TrueCharWidth;
	}
		
	//free(ImageBuffer);
	sfree(ImageBuffer);	//Barry 2008-05-29

	if (!bSuccess)
		return 0;
	else
		return RetWidth;
}
//------------------------------------------------------------------------------------------------
///080115
#ifdef BUILD_SK2851		//Barry 2008-06-18
Uint16 FontTextOutW(FONT_DB *pFontDB, BYTE *str, 
					int UseUTF,
					Uint8 color,
					Uint8 *RGBFrame, Uint16 FrameWidth,
					Uint16 x, Uint16 y, Uint16 w, Uint16 h)
#else
Uint16 FontTextOutW(FONT_DB *pFontDB, BYTE *str, 
					int UseUTF,
					Uint16 color,
					Uint16 *RGBFrame, Uint16 FrameWidth,
					Uint16 x, Uint16 y, Uint16 w, Uint16 h)
#endif
{
	//return
	Uint16 RetWidth = 0;

	//for iconv
	BYTE strtemp[LEN_XXL];
	memset(strtemp, 0, LEN_XXL);
	iconv_t cd = (iconv_t)-1;
	char *inbuf = &str[0];
	char *outbuf = &strtemp[0];
	BYTE *strData = str;
	size_t inbytesleft, outbytesleft, non_rev;
	//int len = 0;

	//code
	WORD codearray[LEN_XL];
	memset(codearray, 0, LEN_XL*sizeof(WORD));
	WORD Code, *pCode;

	//buffer
	BYTE *ImageBuffer = NULL;
#ifdef BUILD_SK2851		//Barry 2008-06-18
	BYTE *pStartFrame, *pRowFrame, *pFrame;
#else
	WORD *pStartFrame, *pRowFrame, *pFrame;
#endif
	BYTE *pRowChar, *pChar;
	WORD TrueCharWidth, TrueCharHeight;
	Uint16 i, j, LenX, LenY;
#ifdef USE_FONTAA	//Ͽ
	BYTE B, G, R;
	Uint16 YF, YB, YM;
#endif

	if (!RGBFrame || !pFontDB || !str)
	{
		return 0;
	}

	//ǳ
	//ImageBuffer = (BYTE*)malloc(pFontDB->FontSize * pFontDB->FontSize * 2);
	ImageBuffer = (BYTE*)salloc(pFontDB->FontSize * pFontDB->FontSize * 2);		//Barry 2008-05-29
	if (!ImageBuffer) return 0;
	if (w == 0 || x + w >= FrameWidth)
	{
		w = FrameWidth - x;
	}

	h = pFontDB->FontSize;
#if 0	//Barry 2008-05-29
	if (h == 0 || y + h >= OUTPUT_YRES)
	{
		h = OUTPUT_YRES - y;
	}
#endif

	if (  UseUTF == 8						//Yw]utf-8
		||
		  (UseUTF == -8 && isUTF8(str) > 0)	//βqutf-8 (iq)
	   )
	{
		if (pFontDB->CharSet == UCS2_CODING)
		{
				cd = g_cd_utf8_2_ucs2;
		}
		else
		{
///080514
#ifdef FONTDB_PRIVATE_CODEPAGE
			if (  pFontDB->cd_utf8_2_local != (iconv_t)-1
				&&
				  pFontDB->bUsePrivateCodepage
			   )
				cd = pFontDB->cd_utf8_2_local;
			else
#endif
///
				cd = g_cd_utf8_2_local;
		}
	}
	else if (UseUTF != 16)	//localsX
	{

		if (pFontDB->CharSet == UCS2_CODING)	//localsXucs2
		{

///080514
#ifdef FONTDB_PRIVATE_CODEPAGE
			if (  pFontDB->cd_local_2_ucs2 != (iconv_t)-1
				&&
				  pFontDB->bUsePrivateCodepage
			   )
				cd = pFontDB->cd_local_2_ucs2;
			else
#endif
///
				cd = g_cd_local_2_ucs2;
		}
	}

	if (cd != (iconv_t)-1)
	{
		inbytesleft = strlenW(str, UseUTF);
		outbytesleft = LEN_XXL;

#ifdef SHARE_CODE_CONV
		CodeConv_Convert(cd, inbuf, inbytesleft, outbuf, outbytesleft);
#else
		non_rev = iconv(cd, (const char**)&inbuf, &inbytesleft, &outbuf, &outbytesleft);
#endif
		//len = (int)LEN_XL - outbytesleft;
		strData = strtemp;
	}

	//OrX
	pCode = &codearray[0];
	if (pFontDB->CharSet == UCS2_CODING)	//UCS2 CӦr2BYTE
	{
		//UCS20x0000
		while (0x0000 != (Code = *((WORD*)strData)))
		{
			if (Code_Cover(pFontDB, Code))
			{
				*pCode++ = Code;
			}
			strData += 2;
		}
	}
	else	//qsX,CӦr1~2BYTE
	{
		Code = 0;
		while (*strData)
		{
			Code |= (WORD)(*strData);
			if (Code_Cover(pFontDB, Code))
			{
				*pCode++ = Code;
				Code = 0;
			}
			else if (  Code > 0x00FF	//byte@_٬OAhոլ
					 &&
					   Code_Cover(pFontDB, (Code&0x00FF))
					)
			{
				*pCode++ = (Code&0x00FF);
				Code = 0;
			}
			else
			{
				Code <<= 8;
			}
			strData++;
		}
	}

	//ѽX
	pStartFrame = RGBFrame + y*FrameWidth + x;
	pCode = &codearray[0];
	while (*pCode && RetWidth < w)
	{
		if (Draw_Char_Image(pFontDB, *pCode, ImageBuffer, &TrueCharHeight, &TrueCharWidth))
		{
			LenX = TrueCharWidth;
			LenY = TrueCharHeight;
			if (RetWidth + TrueCharWidth > w)
			{
				LenX = w - RetWidth;
			}
			if (TrueCharHeight > h)
			{
				LenY = h;
			}
	
			pRowFrame = pStartFrame;
			pRowChar = ImageBuffer;
	
	#ifdef USE_FONTAA
			if (pFontDB->bUseFontAA)
			{
				//nϿϰ2
				FillFontAAMap(ImageBuffer, TrueCharWidth, TrueCharHeight, TrueCharWidth);

				for (i=0; i<LenY; i++)
				{
					pFrame = pRowFrame;
					pChar = pRowChar;
					for (j=0; j<LenX; j++)
					{ 
						if (*pChar == 1)
						{
							*pFrame = color;
						}
						else if (*pChar >= 2)
						{
							B = (color & 0x1F);
							G = (color>>5) & 0x1F;
							R = (color>>10) & 0x1F;
							YF = (Uint16)B + (Uint16)G + (Uint16)R;
							YB = ((*pFrame) & 0x1F) + (((*pFrame)>>5) & 0x1F) + (((*pFrame)>>10) & 0x1F);
							YM = (YF + YB) >> 1;
			
							if (YF <= YM)		//ݭnG
							{
								if (YF > 0)
								{
									B = (Uint8)((Uint16)B * YM / YF);
									G = (Uint8)((Uint16)G * YM / YF);
									R = (Uint8)((Uint16)R * YM / YF);
									if (B < 32) ; else B = 31;
									if (G < 32) ; else G = 31;
									if (R < 32) ; else R = 31;
								}
								else
								{
									B = G = R = (Uint8)(YM/3);
								}
							}
							else				//YF > YMݭnCG
							{
								B = (Uint8)((Uint16)B * YM / YF);
								G = (Uint8)((Uint16)G * YM / YF);
								R = (Uint8)((Uint16)R * YM / YF);							
							}
							*pFrame &= 0x8000;
							*pFrame |= (((Uint16)R)<<10) | (((Uint16)G)<<5) | ((Uint16)B);
						} 
						pFrame++;
						pChar++;
					}
					pRowFrame += FrameWidth;
					pRowChar += TrueCharWidth;/*BufferWidthAlign*/
				}
			}
			else
	#endif
			{
				for (i=0; i<LenY; i++)
				{
					pFrame = pRowFrame;
					pChar = pRowChar;
					for (j=0; j<LenX; j++)
					{
						if (*pChar)
						{
							*pFrame = color;
						}
						pFrame++;
						pChar++;
					}
					pRowFrame += FrameWidth;
					pRowChar += TrueCharWidth;
				}
			}
			
			RetWidth += LenX;
			pStartFrame += LenX;
			x += LenX;
		}
		pCode++;
	}

	//
	//if (ImageBuffer) free(ImageBuffer);
	if (ImageBuffer) sfree(ImageBuffer);		//Barry 2008-05-29
	return RetWidth;
}
///
//------------------------------------------------------------------------------------------------
#if 1	//Barry 2008-05-29
///080115
int isUTF8(BYTE* str)
{
	int len = 0, nGood = 0, nBad = 0;
	BYTE *pCurr, *pPrev;

	if (!str || !(*str))
	{
		return 0;
	}
	else
	{
		pPrev = str;
		if (*(pCurr=pPrev+1) == 0)	//ru1BYTE
		{
			return (*pPrev<0x80 ? 0 : -1);
		}
		while (*pCurr)
		{
			if ((*pCurr & 0xC0) == 0x80)
			{
				if ((*pPrev & 0xC0) == 0xC0)
					nGood++;
				else if ((*pPrev & 0x80) == 0x00)
					nBad++;
			}
			else if ((*pPrev & 0xC0) == 0xC0)
			{
				nBad++;
			}
			pCurr++;
			pPrev++;
		}
		return (1/*nGood*/ - nBad);
	}
}
///
#endif

int getUserLangSetup()
{
#define MAX_LENGTH_OF_STRING	256
#define USER_SETUP_FILE_PATH	"/tmp/User.setup"
#define USER_SETUP_LANGUAGE_POS 0
#define ERROR_ON_PARSE	-1
	FILE *fp;
	char str[MAX_LENGTH_OF_STRING];
	int ret = ERROR_ON_PARSE;
	
	//Open User Descriptor File from somewhere
	if(!(fp = fopen(USER_SETUP_FILE_PATH, "r")))
	{
		//printf("Failed to open user setup file - %s!\n", USER_SETUP_FILE_NAME);
		return ERROR_ON_PARSE;
	}
	else
	{
		//get setup line
		while(fgets(str, MAX_LENGTH_OF_STRING, fp) != NULL)
		{
			//printf("%s", str);
			//skip "// comment" and "$Revision: 1.3 $" lines
			if(str[0] != '/' && str[0] != '$')
				break;
		}
		if(str == NULL)
			return ERROR_ON_PARSE;
		
		//parsing the config line
		int i = 0, idx = 0, tokenIdx = 0, len = strlen(str), t;
		char tmp[10];
		memset(tmp, 0, 10);
		while(i < len && str[i] != '\0')//not eol
		{
			if(str[i] != '#')
				tmp[idx++] = str[i++];
			else
			{
				tmp[idx++] = '\0';
				i++;
				//printf("***%s\n", tmp);
				switch(tokenIdx)
				{
					case USER_SETUP_LANGUAGE_POS:
						t = atoi(tmp);
						ret = t;
						//printf("%d\n", ret);
						break;
					default:
						break;
				}
				idx = 0;
				memset(tmp, 0, 10);
				tokenIdx++;
			}
			
			//skip other user setup
			if(tokenIdx > USER_SETUP_LANGUAGE_POS)
				break;
		}
		fclose(fp);
	}
	return ret;
}


int InitFont()
{
	char strCode[32] = {0};

	//ŪJr
	g_pFontDB_Local = Create_FontDB("/tmp/font.lnk");
	if (!g_pFontDB_Local) return -1;

	switch (getUserLangSetup())
	{
		case SETUP_LANG_English:
		case SETUP_LANG_Italiano:
		case SETUP_LANG_Deutsch:
		case SETUP_LANG_Francais:
		case SETUP_LANG_Espanol:
		case SETUP_LANG_Portuguese:
		case SETUP_LANG_Dutch:
			strcpy(strCode, CODE_PAGE_NAME_ISO8859_1);
			break;
		case SETUP_LANG_CHT:
			strcpy(strCode, CODE_PAGE_NAME_BIG_5);
            break;
        case SETUP_LANG_CHS:
			strcpy(strCode, CODE_PAGE_NAME_GB2312);
            break;
		case SETUP_LANG_JP:
			strcpy(strCode, CODE_PAGE_NAME_SJIS);
            break;
		case SETUP_LANG_KR:
			strcpy(strCode, CODE_PAGE_NAME_KSC);
			break;
		case SETUP_LANG_RUS:
			strcpy(strCode, CODE_PAGE_NAME_CYRILLIC);
			break;
		default:
			break;
	}

	if (*strCode)
	{
		//iconv
		if (g_pFontDB_Local->CharSet == UCS2_CODING)
		{
			g_cd_utf8_2_ucs2 = iconv_open (CODE_PAGE_NAME_UCS_2, CODE_PAGE_NAME_UTF_8);
			g_cd_local_2_ucs2 = iconv_open(CODE_PAGE_NAME_UCS_2, strCode);
		}
		else
		{
			g_cd_utf8_2_local = iconv_open(strCode, CODE_PAGE_NAME_UTF_8);
		}
	}

#if 0	//Barry 2008-05-29
///070824 MwO_ϥΤϿ
#ifdef USE_FONTAA
	if (GetDisplayIndex() == DISP_NTSC || GetDisplayIndex() == DISP_PAL)
	{
		g_pFontDB_Local->bUseFontAA = 1;
	}
#endif
#endif
///
	return 0;
}
 
void CloseFont()
{
	///080115 iconv
	if (g_cd_utf8_2_local != (iconv_t)-1)
		iconv_close(g_cd_utf8_2_local);
	if (g_cd_utf8_2_ucs2 != (iconv_t)-1)
		iconv_close(g_cd_utf8_2_ucs2);
	if (g_cd_local_2_ucs2 != (iconv_t)-1)
		iconv_close(g_cd_local_2_ucs2);
	g_cd_utf8_2_local = (iconv_t)-1;
	g_cd_utf8_2_ucs2 = (iconv_t)-1;
	g_cd_local_2_ucs2 = (iconv_t)-1;
	/// 

	Release_FontDB(&g_pFontDB_Local);
}

