#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <asm/ioctl.h>
#include <fuse.h>

# ifndef DBG_MSG
#define DBG_MSG printf
# endif

# ifndef ERR_MSG
#define ERR_MSG printf
# endif

int Test_arg0	= 8787;
char Test_arg1[10]  = "87654321";
char Test_arg2[10] 	= "10101010";

int main(int argc, char *argv[])
{
		DIR*	pdirh;
		int   dirfdh;
		int 	ret;
		struct fuse_ioctl_arg testarg;
			DBG_MSG("[DBG]:FLICKR IOCTL TEST\n");
			if((pdirh = opendir(argv[1])) == NULL)
	 		{
	 			ERR_MSG("[ERR]:opendir: opendir fail\n");
	 		}
	 		else
	 		{
	 			dirfdh = dirfd(pdirh);
	 			memset(&testarg,0,sizeof(struct fuse_ioctl_arg));
	 			testarg.cmd						 =	7788; // it is command by filesystem interface defined 
	 			testarg.arg_size[0] 	 = sizeof(Test_arg0);		
	 			testarg.parg_data[0]   = &Test_arg0;	// Test_arg0 integer
	 			testarg.arg_size[1] 	 = strlen(Test_arg1) + 1;
	 			testarg.parg_data[1]   = Test_arg1; 	// Test_arg1 array
	 			testarg.arg_size[2] 	 = strlen(Test_arg2) + 1;
	 			testarg.parg_data[2]   = Test_arg2; 	// Test_arg2 array
	 			DBG_MSG("[DBG]:IOCTL_SET\n");
	 			ret = ioctl(dirfdh,FUSE_IOC_SET,&testarg);
	 			memset(&testarg,0,sizeof(struct fuse_ioctl_arg));
	 			testarg.cmd						 =	8877;
	 			testarg.arg_size[0] 	 = sizeof(Test_arg0);
	 			testarg.parg_data[0]   = &Test_arg0;
	 			testarg.arg_size[1] 	 = sizeof(Test_arg1);
	 			testarg.parg_data[1]   = Test_arg1;
	 			testarg.arg_size[2] 	 = sizeof(Test_arg2);
	 			testarg.parg_data[2]   = Test_arg2;
	 			DBG_MSG("[DBG]:IOCTL_GET\n");
	 			ioctl(dirfdh,FUSE_IOC_GET,&testarg);
	 			DBG_MSG("[DBG]: IOCTL_GET arg0:%d\n",Test_arg0);
	 			DBG_MSG("[DBG]: IOCTL_GET arg1:%s\n",Test_arg1);
	 			DBG_MSG("[DBG]: IOCTL_GET arg2:%s\n",Test_arg2);
	 			closedir(pdirh);
	 		}
	 		DBG_MSG("[DBG]:FLICKR IOCTL TEST END\n");
		return 0;
}


