#ifndef __WIFI_CFG_H__
#define __WIFI_CFG_H__


/** Undocumented. */
typedef enum {
    /** Undocumented. */
    IPSOURCE_NONE,

    /** Undocumented. */
    IPSOURCE_STATIC,

    /** Undocumented. */
    IPSOURCE_AUTOIP,

    /** Undocumented. */
    IPSOURCE_DHCP,
} IPSOURCE_TYPE ;

/** Undocumented. */
typedef enum {
    /** Undocumented. */
    MAC_MODE_ADHOC,

    /** Undocumented. */
    MAC_MODE_INFR
} MAC_MODE;

/** Undocumented. */
typedef enum {
    /** Undocumented. */
    MAC_ENCR_NONE,

    /** Undocumented. */
    MAC_ENCR_WEP64,

    /** Undocumented. */
    MAC_ENCR_WEP128,

    /** Undocumented. */
    MAC_ENCR_WPAPSK_TKIP,

    /** Undocumented. */
    MAC_ENCR_WPAPSK_AES,

    /** Undocumented. */
    MAC_ENCR_WPA2PSK_TKIP,

    /** Undocumented. */
    MAC_ENCR_WPA2PSK_AES,
} MAC_ENCR;

/** Undocumented. */
typedef enum {
    /** Undocumented. */
    MAC_AUTH_OPEN,

    /** Undocumented. */
    MAC_AUTH_SHKEY
} MAC_AUTH;

/* Region domains. */
typedef enum {
    REG_FCC=0x10,
    REG_DOC=0x20,
    REG_ETSI=0x30,
    REG_SPAIN=0x31,
    REG_FRANCE=0x32,
    REG_MMK=0x40,
    REG_MMK1=0x41,
    REG_ISRAEL=0x50
} NET_REGION_DOMAIN;

/**
** @brief Network settings to be saved in NVRAM.  These are the standard 
** MAC configurations.
*/
typedef struct {
    /** Ad-Hoc-0, Infr-1 */
    MAC_MODE        Mode ;

    /** None-0, WEP64-1, WEP128-2, WPAPSK-3, WPA2PSK-4 */
    MAC_ENCR        Encr ;

    /** Open-0, ShKey-1 */
    MAC_AUTH        Auth ;

    /** 1-14 */
    unsigned char   Chan ;

    /** Service Set IDentifier */
    char            Ssid[33] ;

    /** 0-3 */
    unsigned char   DefKey ;

    /** 4 Keys upto 16By valid length */
    char   Keys[4][32] ;

    /** 8-64 Characters */
    char            PassPh[64] ;

    /** Country Specific Channels */
    NET_REGION_DOMAIN   RegDomain ;

    /** 256-2346 */
    unsigned long   FragThr ;

    /** 0-2347 */
    unsigned long   RtsThr ;

    /** Boolean */
    //RADIO_SWITCH  Radio ;

    /** Boolean */
    unsigned char   ContTx ;
    
    /** 6 Hexadecimal Numbers */
    //MACADDR    MacAddr ;
} MAC_CONFIG;


typedef struct {
    /** Determines the Source of IP Address */
    IPSOURCE_TYPE           ip_source;

    /** Local IP address */
    unsigned char           addr_ip[4];

    /** Local IP address Subnet mask */
    unsigned char           addr_subnet[4];

    /** Default gateway IP address */
    unsigned char           addr_gateway[4];

    /** Start IP address - For Auto IP */
    unsigned char           addr_start_autoip[4];

    /** End IP address - For Auto IP */
    unsigned char           addr_end_autoip[4];

    /** Status of Different Network Components */
    //NET_STATUS_t            NetStatus ;

    /** IP address of the SMTP server */
    unsigned char           addr_smtp[4];

    /** IP address for the traps to be sent */
    unsigned char           addr_iptrap[4] ;

    /** NETBIOS default group name */
    char                    smb_default_group_name[17];

    /** Default local NETBIOS name */
    char                    smb_default_net_name[17];

    /** Default local NETBIOS description */
    char                    smb_default_net_desc[33];

    /** Administrator password */
    char                    password[12];

    /** Scan-to-email send name. */
    char                    sender_name[21];

    /** Scan-to-email sender email address. */
    char                    sender_addr[41];

    /** Scan-to-email default subject. */
    char                    sender_subj[21];

    /** Scan-to-email default resolution. */
    //NETCB_IMG_RES           scan_res;
} TCP_CONFIG;


typedef struct {
    /** MAC Configuration. */
    MAC_CONFIG Mac_Config;

    /** TCP Configuration. */
    TCP_CONFIG Tcp_Config;
} NETNVRAM_t;


#endif //__WIFI_CFG_H__